
; CC5X Version 3.4B, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  23. Dec 2009  16:26  *************

	processor  16F88
	radix  DEC

	__config 0x2007, 0x802

INDF        EQU   0x00
TMR0        EQU   0x01
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
PA0         EQU   3
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
OPTION_REG  EQU   0x81
ANSEL       EQU   0x9B
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
INT0IF      EQU   1
TMR0IF      EQU   2
RD          EQU   0
EEPGD       EQU   7
FpOverflow  EQU   1
FpUnderFlow EQU   2
FpDiv0      EQU   3
FpRounding  EQU   6
arg1f24     EQU   0x22
arg2f24     EQU   0x25
aarg        EQU   0x28
sign        EQU   0x2A
counter     EQU   0x2B
aarg_2      EQU   0x28
sign_2      EQU   0x2A
counter_2   EQU   0x2B
xtra        EQU   0x28
temp        EQU   0x29
expo        EQU   0x2A
sign_3      EQU   0x2B
expo_2      EQU   0x28
xtra_2      EQU   0x29
sign_4      EQU   0x2A
rval        EQU   0x22
sign_6      EQU   0x28
expo_4      EQU   0x29
xtra_4      EQU   0x2A
rval_3      EQU   0x22
arg1        EQU   0x24
arg2        EQU   0x25
rval_4      EQU   0x26
counter_3   EQU   0x28
arg1_5      EQU   0x29
arg2_5      EQU   0x2B
rm          EQU   0x2C
counter_7   EQU   0x2D
tmp         EQU   0x2E
arg1_6      EQU   0x25
arg2_6      EQU   0x27
rm_2        EQU   0x29
counter_8   EQU   0x2B
arg1_9      EQU   0x29
arg2_9      EQU   0x2B
rm_5        EQU   0x2C
counter_11  EQU   0x2D
tmp_2       EQU   0x2E
arg1_10     EQU   0x25
arg2_10     EQU   0x27
rm_6        EQU   0x29
counter_12  EQU   0x2B
v           EQU   0x32
vmax        EQU   0x34
tampon      EQU   0x36
tampon2     EQU   0x38
nb_timer    EQU   0x3A
var_temps   EQU   0x3C
var_2s      EQU   0x3E
moyenne_1   EQU   0x40
moyenne10   EQU   0x56
moyenne_av1 EQU   0x58
moyenne_av2 EQU   0x5A
moyenne_av3 EQU   0x5C
v1          EQU   0x5F
v2          EQU   0x60
v3          EQU   0x61
v4          EQU   0x62
i           EQU   0x63
a           EQU   0x64
tmr         EQU   0x65
valid_it    EQU   0x66
var_tampon  EQU   0x67
h           EQU   0x68
bit_h_lect  EQU   0x69
bit_l_lect  EQU   0x6A
i_1Min      EQU   0x6B
i_tab       EQU   0x6C
tampon_s    EQU   0x6D
temps_ms    EQU   0x71
fl_temp     EQU   0x74
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
svrPCLATH   EQU   0x21
chaine      EQU   0x25
nb          EQU   0x26
count       EQU   0x27
tempon      EQU   0x28
chiff       EQU   0x25
place       EQU   0x25
temp_2      EQU   0x26
position    EQU   0x22
v_affich    EQU   0x23
heure_h     EQU   0x22
minute_h    EQU   0x23
data_h      EQU   0x25
adresse_ecriture EQU   0x26
bit_h_ecr   EQU   0x27
bit_l_ecr   EQU   0x28
adresse_lecture EQU   0x23
adresse_2   EQU   0x22
i_car_a     EQU   0x22
v_comp      EQU   0x22
bft         EQU   0x24
ci          EQU   0x29

	GOTO main

  ; FILE header_anemo.h
			;#include "int16CXX.h"
			;#define PORT_DATA PORTA
			;#define BP_Horloge PORTA.4
			;#define BP_Gene PORTA.5
			;#define PORT_2S PORTB.4
			;#define PORT_DEL PORTB.3
			;#define PORT_E PORTB.2
			;#define PORT_RS PORTB.1
			;#define TEMPS_MAX 60000 
			;#pragma optimize 0
			;#pragma codepage 1
	ORG 0x0800

  ; FILE C:\Program Files\bknd\CC5X\math24f.h
			;// *************************************************
			;// 24 bit basic floating point math operations
			;// Copyright (c) B Knudsen Data, Norway, 2000 - 2009
			;// *************************************************
			;
			;#pragma library 1
			;/* PROTOTYPES for page definition in application header file:
			;float24 operator* _fmul24( float24 arg1f24, float24 arg2f24);
			;float24 operator/ _fdiv24( float24 arg1f24, float24 arg2f24);
			;float24 operator+ _fadd24( float24 arg1f24, float24 arg2f24);
			;float24 operator- _fsub24( float24 arg1f24, float24 arg2f24);
			;float24 operator= _int24ToFloat24( int24 arg1f24);
			;float24 operator= _int32ToFloat24( int32 arg32);
			;int24 operator= _float24ToInt24( float24 arg1f24);
			;bit operator< _f24_LT_f24( float24 arg1f24, float24 arg2f24);
			;bit operator>= _f24_GE_f24( float24 arg1f24, float24 arg2f24);
			;bit operator> _f24_GT_f24( float24 arg1f24, float24 arg2f24);
			;bit operator<= _f24_LE_f24( float24 arg1f24, float24 arg2f24);
			;*/
			;
			;// DEFINABLE SYMBOLS (in the application code):
			;//#define FP_OPTIM_SPEED  // optimize for SPEED: default
			;//#define FP_OPTIM_SIZE   // optimize for SIZE
			;//#define DISABLE_ROUNDING   // disable rounding and save code space
			;
			;#define float24ToIEEE754(a) { a.mid8=rl(a.mid8); a.high8=rr(a.high8);\
			;                              a.mid8=rr(a.mid8); }
			;#define IEEE754ToFloat24(a) { a.mid8=rl(a.mid8); a.high8=rl(a.high8);\
			;                              a.mid8=rr(a.mid8); }
			;
			;
			;/*  24 bit floating point format:
			;
			;  address  ID
			;    X      a.low8  : LSB, bit 0-7 of mantissa
			;    X+1    a.mid8  : bit 8-14 of mantissa, bit 15 is the sign bit
			;    X+2    a.high8 : MSB, bit 0-7 of exponent, with bias 0x7F
			;
			;    bit 15 of mantissa is a hidden bit, always equal to 1
			;    zero (0.0) :  a.high8 = 0 (mantissa & sign ignored)
			;
			;   MSB    LSB
			;    7F 00 00  : 1.0   =  1.0  * 2**(0x7F-0x7F) = 1.0 * 1
			;    7F 80 00  : -1.0  = -1.0  * 2**(0x7F-0x7F) = -1.0 * 1
			;    80 00 00  : 2.0   =  1.0  * 2**(0x80-0x7F) = 1.0 * 2
			;    80 40 00  : 3.0   =  1.5  * 2**(0x80-0x7F) = 1.5 * 2
			;    7E 60 00  : 0.875 =  1.75 * 2**(0x7E-0x7F) = 1.75 * 0.5
			;    7F 60 00  : 1.75  =  1.75 * 2**(0x7E-0x7F) = 1.75 * 1
			;    7F 7F FF  : 1.999969482
			;    00 7C 5A  : 0.0 (mantissa & sign ignored)
			;    01 00 00  : 1.17549435e-38 =  1.0 * 2**(0x01-0x7F)
			;    FE 7F FF  : 3.40277175e+38 =  1.999969482 * 2**(0xFE-0x7F)
			;    FF 00 00  : +INF : positive infinity
			;    FF 80 00  : -INF : negative infinity
			;*/                 
			;
			;#define  FpBIAS  0x7F
			;
			;#ifndef FpFlags_defined
			; #define FpFlags_defined
			;
			; char FpFlags;
			; //bit IOV         @ FpFlags.0; // integer overflow flag: NOT USED
			; bit FpOverflow    @ FpFlags.1; // floating point overflow flag
			; bit FpUnderFlow   @ FpFlags.2; // floating point underflow flag
			; bit FpDiv0        @ FpFlags.3; // floating point divide by zero flag
			; //bit FpNAN       @ FpFlags.4; // not-a-number exception flag: NOT USED
			; bit FpDomainError @ FpFlags.5; // domain error exception flag
			; bit FpRounding    @ FpFlags.6; // floating point rounding flag, 0=truncation
			;                                // 1 = unbiased rounding to nearest LSB
			; //bit FpSaturate  @ FpFlags.7; // floating point saturate flag: NOT USED
			;
			; #pragma floatOverflow FpOverflow
			; #pragma floatUnderflow FpUnderFlow
			;
			; #define InitFpFlags()  FpFlags = 0x40 /* enable rounding as default */
			;#endif
			;
			;#ifdef DISABLE_ROUNDING
			; #pragma floatRounding 0
			;#endif
			;
			;
			;#if __CoreSet__ < 1410
			; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W
			; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W
			; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W
			; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W
			;#else
			; #define genAdd(r,a) W=a; r=addWFC(r)
			; #define genSub(r,a) W=a; r=subWFB(r)
			; #define genAddW(r,a) W=a; W=addWFC(r)
			; #define genSubW(r,a) W=a; W=subWFB(r)
			;#endif
			;
			;
			;
			;float24 operator* _fmul24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fmul24
			;    uns16 aarg;
			;    W = arg1f24.mid8;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+1,W
			;    aarg.high8 = W;
	MOVWF aarg+1
			;
			;    // save sign
			;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
	XORWF arg2f24+1,W
	MOVWF sign
			;
			;    W = arg1f24.high8;
	MOVF  arg1f24+2,W
			;    if (!Zero_)
	BTFSC 0x03,Zero_
	GOTO  m001
			;        W = arg2f24.high8;
	MOVF  arg2f24+2,W
			;    if (Zero_)
m001	BTFSS 0x03,Zero_
	GOTO  m002
			;        goto RES0;
	GOTO  m012
			;
			;    arg1f24.high8 += W /* arg2f24.high8 */;
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF arg1f24+2,1
			;    W = FpBIAS-1;
	MOVLW 126
			;    if (Carry)  {
	BTFSS 0x03,Carry
	GOTO  m004
			;        arg1f24.high8 -= W;
	SUBWF arg1f24+2,1
			;        if (Carry)
	BTFSS 0x03,Carry
	GOTO  m003
			;            goto OVERFLOW;
	GOTO  m013
			;    }
			;    else  {
m003	GOTO  m005
			;        arg1f24.high8 -= W;
m004	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF arg1f24+2,1
			;        if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m005
			;            goto UNDERFLOW;
	GOTO  m011
			;    }
			;    aarg.low8 = arg1f24.low8;
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	MOVWF aarg
			;
			;    aarg.15 = 1;
	BSF   aarg+1,7
			;    arg2f24.15 = 1;
	BSF   arg2f24+1,7
			;
			;    arg1f24.low16 = 0;
	CLRF  arg1f24
	CLRF  arg1f24+1
			;
			;    char counter = sizeof(aarg)*8;
	MOVLW 16
	MOVWF counter
			;
			;    do  {
			;        aarg = rr( aarg);
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   aarg+1,1
	RRF   aarg,1
			;        if (Carry)  {
	BTFSS 0x03,Carry
	GOTO  m007
			;            arg1f24.low8 += arg2f24.low8;
	MOVF  arg2f24,W
	ADDWF arg1f24,1
			;            genAdd( arg1f24.mid8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSC 0x03,Carry
	INCFSZ arg2f24+1,W
	ADDWF arg1f24+1,1
			;        }
			;        arg1f24.low16 = rr( arg1f24.low16);
m007	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;    } while (-- counter > 0);
	DECF  counter,1
	MOVF  counter,1
	BTFSS 0x03,Zero_
	GOTO  m006
			;
			;    if (!arg1f24.15)  {
	BTFSC arg1f24+1,7
	GOTO  m009
			;        // catch Carry bit that was shifted out previously
			;        arg1f24.low16 = rl( arg1f24.low16);
	RLF   arg1f24,1
	RLF   arg1f24+1,1
			;        if (arg1f24.high8 == 0)
	MOVF  arg1f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m008
			;            goto UNDERFLOW;
	GOTO  m011
			;        arg1f24.high8 -= 1;
m008	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  arg1f24+2,1
			;        W = rl( aarg.high8);
	RLF   aarg+1,W
			;        // restore bit behind LSB in Carry
			;    }
			;
			;   #ifndef DISABLE_ROUNDING
			;    if (FpRounding  &&  Carry)  {
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x2F,FpRounding
	GOTO  m010
	BTFSS 0x03,Carry
	GOTO  m010
			;        arg1f24.low8 += 1;
	INCF  arg1f24,1
			;        if (!arg1f24.low8)  {
	MOVF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m010
			;            arg1f24.mid8 += 1;
	INCF  arg1f24+1,1
			;            if (!arg1f24.mid8)  {
	MOVF  arg1f24+1,1
	BTFSS 0x03,Zero_
	GOTO  m010
			;                // Carry = 1; //OK
			;                arg1f24.low16 = rr( arg1f24.low16);
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;                arg1f24.high8 += 1;
	INCF  arg1f24+2,1
			;                if (Zero_)
	BTFSS 0x03,Zero_
	GOTO  m010
			;                    goto OVERFLOW;
	GOTO  m013
			;            }
			;        }
			;    }
			;   #endif
			;    goto SET_SIGN;
m010	GOTO  m015
			;
			;  UNDERFLOW:
			;    FpUnderFlow = 1;
m011	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpUnderFlow
			;  RES0:
			;    arg1f24.high8 = 0;
m012	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  arg1f24+2
			;    goto MANTISSA;
	GOTO  m014
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
m013	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpOverflow
			;    arg1f24.high8 = 0xFF;
	MOVLW 255
	MOVWF arg1f24+2
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
m014	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  arg1f24
	MOVLW 128
	MOVWF arg1f24+1
			;
			;  SET_SIGN:
			;    if (!(sign & 0x80))
m015	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC sign,7
	GOTO  m016
			;        arg1f24.15 = 0;
	BCF   arg1f24+1,7
			;    return arg1f24;
m016	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	RETURN
			;}
			;
			;
			;
			;float24 operator/ _fdiv24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fdiv24
			;    uns16 aarg;
			;    W = arg1f24.mid8;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+1,W
			;    aarg.high8 = W;
	MOVWF aarg_2+1
			;
			;    // save sign
			;    char sign = arg2f24.mid8 ^ W;  // before first overflow test
	XORWF arg2f24+1,W
	MOVWF sign_2
			;
			;    W = arg2f24.high8;
	MOVF  arg2f24+2,W
			;    if (Zero_)
	BTFSS 0x03,Zero_
	GOTO  m017
			;        goto Div0;
	GOTO  m035
			;    if (!arg1f24.high8)
m017	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m018
			;        goto RES0;
	GOTO  m037
			;
			;    arg1f24.high8 -= arg2f24.high8;
m018	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24+2,W
	SUBWF arg1f24+2,1
			;    W = FpBIAS;
	MOVLW 127
			;    if (!Carry)  {
	BTFSC 0x03,Carry
	GOTO  m020
			;        arg1f24.high8 += W;
	ADDWF arg1f24+2,1
			;        if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m019
			;            goto UNDERFLOW;
	GOTO  m036
			;    }
			;    else  {
m019	GOTO  m021
			;        arg1f24.high8 += W;
m020	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF arg1f24+2,1
			;        if (Carry)
	BTFSS 0x03,Carry
	GOTO  m021
			;            goto OVERFLOW;
	GOTO  m038
			;    }
			;
			;    aarg.low8 = arg1f24.low8;
m021	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	MOVWF aarg_2
			;    aarg.15 = 1;
	BSF   aarg_2+1,7
			;    arg2f24.15 = 1;
	BSF   arg2f24+1,7
			;
			;    // division: shift & add
			;    char counter = 16;
	MOVLW 16
	MOVWF counter_2
			;    arg1f24.low16 = 0;  // speedup
	CLRF  arg1f24
	CLRF  arg1f24+1
			;
			;#if defined FP_OPTIM_SPEED || !defined FP_OPTIM_SIZE  // SPEED
			;
			;    goto START_ML;
	GOTO  m025
			;
			;  TEST_ZERO_L:
			;    W = aarg.low8 - arg2f24.low8;
m022	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24,W
	SUBWF aarg_2,W
			;    if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m023
			;        goto SHIFT_IN_CARRY;
	GOTO  m029
			;    aarg.low8 = W;
m023	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF aarg_2
			;    aarg.high8 = 0;
	CLRF  aarg_2+1
			;    goto SET_AND_SHIFT_IN_CARRY;
	GOTO  m028
			;
			;// MAIN LOOP
			;    do  {
			;      LOOP_ML:
			;        if (!Carry)  {
m024	BTFSC 0x03,Carry
	GOTO  m027
			;           START_ML:
			;            W = aarg.high8 - arg2f24.mid8;
m025	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24+1,W
	SUBWF aarg_2+1,W
			;            if (Zero_)
	BTFSS 0x03,Zero_
	GOTO  m026
			;                goto TEST_ZERO_L;
	GOTO  m022
			;            if (!Carry)
m026	BTFSC 0x03,Carry
	GOTO  m027
			;                goto SHIFT_IN_CARRY;
	GOTO  m029
			;        }
			;        aarg.low8 -= arg2f24.low8;
m027	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24,W
	SUBWF aarg_2,1
			;        genSub( aarg.high8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2f24+1,W
	SUBWF aarg_2+1,1
			;      SET_AND_SHIFT_IN_CARRY:
			;        Carry = 1;
m028	BSF   0x03,Carry
			;      SHIFT_IN_CARRY:
			;        arg1f24.low16 = rl( arg1f24.low16);
m029	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   arg1f24,1
	RLF   arg1f24+1,1
			;        // Carry = 0;  // ok, speedup
			;        aarg = rl( aarg);
	RLF   aarg_2,1
	RLF   aarg_2+1,1
			;    } while (-- counter > 0);
	DECF  counter_2,1
	MOVF  counter_2,1
	BTFSS 0x03,Zero_
	GOTO  m024
			;
			;
			;
			;#else  // SIZE
			;
			;    goto START_ML;
			;
			;// MAIN LOOP
			;    do  {
			;      LOOP_ML:
			;        if (Carry)
			;            goto SUBTRACT;
			;      START_ML:
			;        W = aarg.low8 - arg2f24.low8;
			;        genSubW( aarg.high8, arg2f24.mid8);
			;        if (!Carry)
			;            goto SKIP_SUB;
			;       SUBTRACT:
			;        aarg.low8 -= arg2f24.low8;
			;        genSub( aarg.high8, arg2f24.mid8);
			;        Carry = 1;
			;       SKIP_SUB:
			;        arg1f24.low16 = rl( arg1f24.low16);
			;        // Carry = 0;  // ok
			;        aarg = rl( aarg);
			;    } while (-- counter > 0);
			;
			;#endif
			;
			;    if (!arg1f24.15)  {
	BTFSC arg1f24+1,7
	GOTO  m031
			;        if (!arg1f24.high8)
	MOVF  arg1f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m030
			;            goto UNDERFLOW;
	GOTO  m036
			;        arg1f24.high8 --;
m030	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  arg1f24+2,1
			;        counter ++;
	INCF  counter_2,1
			;        goto LOOP_ML;
	GOTO  m024
			;    }
			;
			;   #ifndef DISABLE_ROUNDING
			;    if (FpRounding)  {
m031	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x2F,FpRounding
	GOTO  m034
			;        if (Carry)
	BTFSS 0x03,Carry
	GOTO  m032
			;            goto ADD_1;
	GOTO  m033
			;        aarg.low8 -= arg2f24.low8;
m032	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24,W
	SUBWF aarg_2,1
			;        genSub( aarg.high8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2f24+1,W
	SUBWF aarg_2+1,1
			;        if (Carry)  {
	BTFSS 0x03,Carry
	GOTO  m034
			;          ADD_1:
			;            arg1f24.low8 += 1;
m033	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  arg1f24,1
			;            if (!arg1f24.low8)  {
	MOVF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m034
			;                arg1f24.mid8 ++;
	INCF  arg1f24+1,1
			;                if (!arg1f24.mid8)  {
	MOVF  arg1f24+1,1
	BTFSS 0x03,Zero_
	GOTO  m034
			;                    arg1f24.low16 = rr( arg1f24.low16);
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;                    arg1f24.high8 ++;
	INCF  arg1f24+2,1
			;                    if (!arg1f24.high8)
	MOVF  arg1f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m034
			;                        goto OVERFLOW;
	GOTO  m038
			;                }
			;            }
			;        }
			;    }
			;   #endif
			;    goto SET_SIGN;
m034	GOTO  m041
			;
			;  Div0:
			;    FpDiv0 = 1;
m035	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpDiv0
			;    goto SATURATE;
	GOTO  m039
			;
			;  UNDERFLOW:
			;    FpUnderFlow = 1;
m036	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpUnderFlow
			;  RES0:
			;    arg1f24.high8 = 0;
m037	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  arg1f24+2
			;    goto MANTISSA;
	GOTO  m040
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
m038	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpOverflow
			;  SATURATE:
			;    arg1f24.high8 = 0xFF;
m039	MOVLW 255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg1f24+2
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
m040	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  arg1f24
	MOVLW 128
	MOVWF arg1f24+1
			;
			;  SET_SIGN:
			;    if (!(sign & 0x80))
m041	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC sign_2,7
	GOTO  m042
			;        arg1f24.15 = 0;
	BCF   arg1f24+1,7
			;    return arg1f24;
m042	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	RETURN
			;}
			;
			;
			;float24 operator+ _fadd24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fadd24
			;    char xtra, temp;
			;    char expo = arg1f24.high8 - arg2f24.high8;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24+2,W
	SUBWF arg1f24+2,W
	MOVWF expo
			;    if (!Carry)  {
	BTFSC 0x03,Carry
	GOTO  m043
			;        expo = -expo;
	COMF  expo,1
	INCF  expo,1
			;        temp = arg1f24.high8;
	MOVF  arg1f24+2,W
	MOVWF temp
			;        arg1f24.high8 = arg2f24.high8;
	MOVF  arg2f24+2,W
	MOVWF arg1f24+2
			;        arg2f24.high8 = temp;
	MOVF  temp,W
	MOVWF arg2f24+2
			;        temp = arg1f24.mid8;
	MOVF  arg1f24+1,W
	MOVWF temp
			;        arg1f24.mid8 = arg2f24.mid8;
	MOVF  arg2f24+1,W
	MOVWF arg1f24+1
			;        arg2f24.mid8 = temp;
	MOVF  temp,W
	MOVWF arg2f24+1
			;        temp = arg1f24.low8;
	MOVF  arg1f24,W
	MOVWF temp
			;        arg1f24.low8 = arg2f24.low8;
	MOVF  arg2f24,W
	MOVWF arg1f24
			;        arg2f24.low8 = temp;
	MOVF  temp,W
	MOVWF arg2f24
			;    }
			;    if (expo > sizeof(arg1f24)*8-7)
m043	MOVLW 18
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF expo,W
	BTFSS 0x03,Carry
	GOTO  m044
			;        goto _RETURN_MF;
	GOTO  m069
			;    if (!arg2f24.high8)
m044	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m045
			;        goto _RETURN_MF;   // result is arg1f24
	GOTO  m069
			;
			;    xtra = 0;
m045	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  xtra
			;
			;    temp = arg1f24.mid8;
	MOVF  arg1f24+1,W
	MOVWF temp
			;    char sign = arg2f24.mid8 ^ arg1f24.mid8;
	MOVF  arg1f24+1,W
	XORWF arg2f24+1,W
	MOVWF sign_3
			;    arg1f24.15 = 1;
	BSF   arg1f24+1,7
			;    arg2f24.15 = 1;
	BSF   arg2f24+1,7
			;
			;    while (1)  {
			;        W = 8;
m046	MOVLW 8
			;        expo -= W;
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF expo,1
			;        if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m047
			;            break;
	GOTO  m048
			;        xtra = arg2f24.low8;
m047	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24,W
	MOVWF xtra
			;        arg2f24.low8 = arg2f24.mid8;
	MOVF  arg2f24+1,W
	MOVWF arg2f24
			;        arg2f24.mid8 = 0;
	CLRF  arg2f24+1
			;    }
	GOTO  m046
			;    expo += W;
m048	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF expo,1
			;    if (expo)  {
	MOVF  expo,1
	BTFSC 0x03,Zero_
	GOTO  m050
			;        do  {
			;            Carry = 0;
m049	BCF   0x03,Carry
			;            arg2f24.low16 = rr( arg2f24.low16);
	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   arg2f24+1,1
	RRF   arg2f24,1
			;            xtra = rr( xtra);
	RRF   xtra,1
			;        } while (--expo > 0);
	DECF  expo,1
	MOVF  expo,1
	BTFSS 0x03,Zero_
	GOTO  m049
			;    }
			;
			;
			;    if (sign & 0x80)  {
m050	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS sign_3,7
	GOTO  m060
			;        // SUBTRACT
			;        arg1f24.low8 -= arg2f24.low8;
	MOVF  arg2f24,W
	SUBWF arg1f24,1
			;        genSub( arg1f24.mid8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2f24+1,W
	SUBWF arg1f24+1,1
			;        if (!Carry)  {  // arg2f24 > arg1f24
	BTFSC 0x03,Carry
	GOTO  m051
			;            arg1f24.low16 = -arg1f24.low16;
	COMF  arg1f24+1,1
	COMF  arg1f24,1
	INCF  arg1f24,1
	BTFSC 0x03,Zero_
	INCF  arg1f24+1,1
			;            // xtra == 0 because arg1f24.exp == arg2f24.exp
			;            temp ^= 0x80;  // invert sign
	MOVLW 128
	XORWF temp,1
			;        }
			;        xtra = -xtra;
m051	BCF   0x03,RP0
	BCF   0x03,RP1
	COMF  xtra,1
	INCF  xtra,1
			;        if (xtra)
	MOVF  xtra,1
	BTFSC 0x03,Zero_
	GOTO  m052
			;            arg1f24.low16 --;
	DECF  arg1f24,1
	INCF  arg1f24,W
	BTFSC 0x03,Zero_
	DECF  arg1f24+1,1
			;        // adjust result left
			;       #define counter expo
			;        counter = 3;
m052	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF expo
			;        while (!arg1f24.mid8)  {
m053	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+1,1
	BTFSS 0x03,Zero_
	GOTO  m056
			;            arg1f24.mid8 = arg1f24.low8;
	MOVF  arg1f24,W
	MOVWF arg1f24+1
			;            arg1f24.low8 = xtra;
	MOVF  xtra,W
	MOVWF arg1f24
			;            xtra = 0;
	CLRF  xtra
			;            arg1f24.high8 -= 8;
	MOVLW 8
	SUBWF arg1f24+2,1
			;            if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m054
			;                goto RES0;
	GOTO  m065
			;            if (--counter == 0)  // max 2 iterations
m054	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  expo,1
	MOVF  expo,1
	BTFSS 0x03,Zero_
	GOTO  m055
			;                goto RES0;
	GOTO  m065
			;        }
m055	GOTO  m053
			;       #undef counter
			;        while (!arg1f24.15)  {
m056	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC arg1f24+1,7
	GOTO  m058
			;            Carry = 0;
	BCF   0x03,Carry
			;            xtra = rl( xtra);
	RLF   xtra,1
			;            arg1f24.low16 = rl( arg1f24.low16);
	RLF   arg1f24,1
	RLF   arg1f24+1,1
			;            arg1f24.high8 --;
	DECF  arg1f24+2,1
			;            if (!arg1f24.high8)
	MOVF  arg1f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m057
			;                goto RES0;   // UNDERFLOW?
	GOTO  m065
			;        }
m057	GOTO  m056
			;       #ifndef DISABLE_ROUNDING
			;        if (FpRounding  &&  (xtra & 0x80))  {
m058	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x2F,FpRounding
	GOTO  m059
	BTFSS xtra,7
	GOTO  m059
			;            xtra = 0; // disable recursion
	CLRF  xtra
			;            goto INCREMENT;
	GOTO  m063
			;        }
			;       #endif
			;    }
			;    else  {
m059	GOTO  m064
			;        // ADD arg1f24 and arg2f24
			;        arg1f24.low8 += arg2f24.low8;
m060	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg2f24,W
	ADDWF arg1f24,1
			;        genAdd( arg1f24.mid8, arg2f24.mid8);
	MOVF  arg2f24+1,W
	BTFSC 0x03,Carry
	INCFSZ arg2f24+1,W
	ADDWF arg1f24+1,1
			;        if (Carry)  {
	BTFSS 0x03,Carry
	GOTO  m062
			;          ADJUST_RIGHT:
			;            arg1f24.low16 = rr( arg1f24.low16);
m061	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;            xtra = rr( xtra);
	RRF   xtra,1
			;            arg1f24.high8 += 1;  // exp
	INCF  arg1f24+2,1
			;            if (!arg1f24.high8)
	MOVF  arg1f24+2,1
	BTFSS 0x03,Zero_
	GOTO  m062
			;                goto OVERFLOW;
	GOTO  m066
			;        }
			;       #ifndef DISABLE_ROUNDING
			;        if (FpRounding  &&  (xtra & 0x80))  {
m062	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x2F,FpRounding
	GOTO  m064
	BTFSS xtra,7
	GOTO  m064
			;          INCREMENT:
			;            arg1f24.low8 += 1;
m063	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  arg1f24,1
			;            if (!arg1f24.low8)  {
	MOVF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m064
			;                arg1f24.mid8 += 1;
	INCF  arg1f24+1,1
			;                if (!arg1f24.mid8)  {
	MOVF  arg1f24+1,1
	BTFSS 0x03,Zero_
	GOTO  m064
			;                    Carry = 1; // prepare for shift
	BSF   0x03,Carry
			;                    arg1f24.0 = 0;  // disable recursion
	BCF   arg1f24,0
			;                    goto ADJUST_RIGHT;
	GOTO  m061
			;                }
			;            }
			;        }
			;       #endif
			;    }
			;    goto SET_SIGN;
m064	GOTO  m068
			;
			;//  UNDERFLOW:
			;//    FpUnderFlow = 1;
			;  RES0:
			;    arg1f24.high8 = 0;
m065	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  arg1f24+2
			;    goto MANTISSA;
	GOTO  m067
			;
			;  OVERFLOW:
			;    FpOverflow = 1;
m066	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpOverflow
			;    arg1f24.high8 = 0xFF;
	MOVLW 255
	MOVWF arg1f24+2
			;  MANTISSA:
			;    arg1f24.low16 = 0x8000;
m067	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  arg1f24
	MOVLW 128
	MOVWF arg1f24+1
			;
			;  SET_SIGN:
			;    if (!(temp & 0x80))
m068	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC temp,7
	GOTO  m069
			;        arg1f24.15 = 0;
	BCF   arg1f24+1,7
			;
			;  _RETURN_MF:
			;    return arg1f24;
m069	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	RETURN
			;}
			;
			;
			;// SUBTRACTION
			;
			;float24 operator- _fsub24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_fsub24
			;    arg2f24.mid8 ^= 0x80;
			;    arg1f24 += arg2f24;
			;    return arg1f24;
			;}
			;
			;
			;float24 operator=( int8 arg) @
			;float24 operator=( uns8 arg) @
			;float24 operator=( int16 arg) @
			;float24 operator=( uns16 arg) @
			;float24 operator= _int24ToFloat24( sharedM int24 arg1f24)
			;{
_int24ToFloat24
			;    sharedM float24 arg2f24;   // unused, but required
			;    char expo = FpBIAS + 16 - 1;
	MOVLW 142
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF expo_2
			;    char xtra = 0;
	CLRF  xtra_2
			;    char sign = 0;
	CLRF  sign_4
			;    if (arg1f24 < 0)  {
	BTFSS arg1f24+2,7
	GOTO  m071
			;        arg1f24 = -arg1f24;
	COMF  arg1f24+2,1
	COMF  arg1f24+1,1
	COMF  arg1f24,1
	INCF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m070
	INCF  arg1f24+1,1
	BTFSC 0x03,Zero_
	INCF  arg1f24+2,1
			;        sign |= 0x80;
m070	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   sign_4,7
			;    }
			;    if (arg1f24.high8)  {
m071	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+2,1
	BTFSC 0x03,Zero_
	GOTO  m072
			;        expo += 8;
	MOVLW 8
	ADDWF expo_2,1
			;        xtra = arg1f24.low8;
	MOVF  arg1f24,W
	MOVWF xtra_2
			;        arg1f24.low8 = arg1f24.mid8;
	MOVF  arg1f24+1,W
	MOVWF arg1f24
			;        arg1f24.mid8 = arg1f24.high8;
	MOVF  arg1f24+2,W
	MOVWF arg1f24+1
			;    }
			;    else if (!arg1f24.mid8)  {
	GOTO  m074
m072	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+1,1
	BTFSS 0x03,Zero_
	GOTO  m074
			;        expo -= 8;
	MOVLW 8
	SUBWF expo_2,1
			;        W = arg1f24.low8;
	MOVF  arg1f24,W
			;        if (!W)
	XORLW 0
	BTFSS 0x03,Zero_
	GOTO  m073
			;            goto _RETURN_MF;
	GOTO  m078
			;        arg1f24.mid8 = W;
m073	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg1f24+1
			;        arg1f24.low8 = 0;
	CLRF  arg1f24
			;    }
			;
			;    // arg1f24.mid8 != 0
			;    goto TEST_ARG1_B15;
m074	GOTO  m076
			;    do  {
			;        xtra = rl( xtra);
m075	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   xtra_2,1
			;        arg1f24.low16 = rl( arg1f24.low16);
	RLF   arg1f24,1
	RLF   arg1f24+1,1
			;        expo --;
	DECF  expo_2,1
			;      TEST_ARG1_B15:
			;    } while (!arg1f24.15);
m076	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS arg1f24+1,7
	GOTO  m075
			;
			;   #ifndef DISABLE_ROUNDING
			;    if (FpRounding && (xtra & 0x80))  {
	BTFSS 0x2F,FpRounding
	GOTO  m077
	BTFSS xtra_2,7
	GOTO  m077
			;        arg1f24.low8 += 1;
	INCF  arg1f24,1
			;        if (!arg1f24.low8)  {
	MOVF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m077
			;            arg1f24.mid8 += 1;
	INCF  arg1f24+1,1
			;            if (!arg1f24.mid8)  {
	MOVF  arg1f24+1,1
	BTFSS 0x03,Zero_
	GOTO  m077
			;                Carry = 1;
	BSF   0x03,Carry
			;                arg1f24.low16 = rr( arg1f24.low16);
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;                expo ++;
	INCF  expo_2,1
			;            }
			;        }
			;    }
			;   #endif
			;
			;    arg1f24.high8 = expo;
m077	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  expo_2,W
	MOVWF arg1f24+2
			;    if (!(sign & 0x80))
	BTFSC sign_4,7
	GOTO  m078
			;        arg1f24.15 = 0;
	BCF   arg1f24+1,7
			;
			;  _RETURN_MF:
			;    float24 rval @ arg1f24;
			;    rval.low24 = arg1f24.low24;
			;    return rval;
m078	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  rval,W
	RETURN
			;}
			;
			;
			;float24 operator=( uns24 arg) @
			;float24 operator= _int32ToFloat24( int32 arg32)
			;{
_int32ToFloat24
			;    char expo = FpBIAS + 16 - 1;
			;    char xtra @ arg32.high8;
			;    char sign = 0;
			;    if (arg32 < 0)  {
			;        arg32 = -arg32;
			;        sign |= 0x80;
			;    }
			;    if (arg32.high8)  {
			;        expo += 8;
			;        arg32.low8 = arg32.midL8;
			;        arg32.midL8 = arg32.midH8;
			;        arg32.midH8 = arg32.high8;
			;        arg32.high8 = 0;
			;    }
			;    if (arg32.midH8)  {
			;        expo += 8;
			;        xtra = arg32.low8;
			;        arg32.low8 = arg32.midL8;
			;        arg32.midL8 = arg32.midH8;
			;    }
			;    else if (!arg32.midL8)  {
			;        expo -= 8;
			;        W = arg32.low8;
			;        if (!W)
			;            goto _RETURN_MF;
			;        arg32.midL8 = W;
			;        arg32.low8 = 0;
			;    }
			;
			;    // arg32.midL8 != 0
			;    goto TEST_ARG_B15;
			;    do  {
			;        xtra = rl( xtra);
			;        arg32.low16 = rl( arg32.low16);
			;        expo --;
			;      TEST_ARG_B15:
			;    } while (!arg32.15);
			;
			;   #ifndef DISABLE_ROUNDING
			;    if (FpRounding && (xtra & 0x80))  {
			;        arg32.low8 += 1;
			;        if (!arg32.low8)  {
			;            arg32.midL8 += 1;
			;            if (!arg32.midL8)  {
			;                Carry = 1;
			;                arg32.low16 = rr( arg32.low16);
			;                expo ++;
			;            }
			;        }
			;    }
			;   #endif
			;
			;    arg32.midH8 = expo;
			;    if (!(sign & 0x80))
			;        arg32.15 = 0;
			;
			;  _RETURN_MF:
			;    float24 rval @ arg32;
			;    rval.low24 = arg32.low24;
			;    return rval;
			;}
			;
			;
			;uns8 operator=( sharedM float24 arg1f24) @
			;int8 operator=( sharedM float24 arg1f24) @
			;uns16 operator=( sharedM float24 arg1f24) @
			;int16 operator=( sharedM float24 arg1f24) @
			;int24 operator= _float24ToInt24( sharedM float24 arg1f24)
			;{
_float24ToInt24
			;    sharedM float24 arg2f24;   // unused, but required
			;    char sign = arg1f24.mid8;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+1,W
	MOVWF sign_6
			;    char expo = arg1f24.high8 - (FpBIAS-1);
	MOVLW 126
	SUBWF arg1f24+2,W
	MOVWF expo_4
			;    if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m079
			;        goto RES0;
	GOTO  m086
			;    arg1f24.15 = 1;
m079	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   arg1f24+1,7
			;
			;    arg1f24.high8 = 0;
	CLRF  arg1f24+2
			;   #ifndef DISABLE_ROUNDING
			;    char xtra = 0;
	CLRF  xtra_4
			;   #endif
			;
			;    // (a): expo = 0..8 : shift 1 byte to the right
			;    // (b): expo = 9..16: shift 0 byte
			;    // (c): expo = 17..24: shift 1 byte to the left
			;   #if __CoreSet__ / 100 == 12
			;    expo -= 17;
			;    expo = 0xFF - expo;  // COMF (Carry unchanged)
			;    if (Carry)  {  // (c)
			;   #else
			;    expo = 16 - expo;
	MOVF  expo_4,W
	SUBLW 16
	MOVWF expo_4
			;    if (!Carry)  {  // (c)
	BTFSC 0x03,Carry
	GOTO  m081
			;   #endif
			;        expo += 8;
	MOVLW 8
	ADDWF expo_4,1
			;        if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m080
			;            goto OVERFLOW;
	GOTO  m085
			;        arg1f24.high8 = arg1f24.mid8;
m080	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24+1,W
	MOVWF arg1f24+2
			;        arg1f24.mid8 = arg1f24.low8;
	MOVF  arg1f24,W
	MOVWF arg1f24+1
			;        arg1f24.low8 = 0;
	CLRF  arg1f24
			;    }
			;    else  {  // (a) (b)
	GOTO  m082
			;        // expo = 0 .. 16
			;        W = expo - 8;
m081	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF expo_4,W
			;        if (Carry)  {  // (a)
	BTFSS 0x03,Carry
	GOTO  m082
			;            expo = W;
	MOVWF expo_4
			;           #ifndef DISABLE_ROUNDING
			;            xtra = arg1f24.low8;
	MOVF  arg1f24,W
	MOVWF xtra_4
			;           #endif
			;            arg1f24.low8 = arg1f24.mid8;
	MOVF  arg1f24+1,W
	MOVWF arg1f24
			;            arg1f24.mid8 = 0;
	CLRF  arg1f24+1
			;        }
			;    }
			;    if (expo)  {
m082	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  expo_4,1
	BTFSC 0x03,Zero_
	GOTO  m084
			;        do  {
			;            Carry = 0;
m083	BCF   0x03,Carry
			;            arg1f24.high8 = rr( arg1f24.high8);
	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   arg1f24+2,1
			;            arg1f24.low16 = rr( arg1f24.low16);
	RRF   arg1f24+1,1
	RRF   arg1f24,1
			;           #ifndef DISABLE_ROUNDING
			;            xtra = rr( xtra);
	RRF   xtra_4,1
			;           #endif
			;        } while (--expo);
	DECF  expo_4,1
	MOVF  expo_4,1
	BTFSS 0x03,Zero_
	GOTO  m083
			;    }
			;    if (arg1f24.23)  {
m084	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS arg1f24+2,7
	GOTO  m088
			;       OVERFLOW:
			;        FpOverflow = 1;
m085	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x2F,FpOverflow
			;        W = 0xFF;
	MOVLW 255
			;        goto ASSIGNW;
	GOTO  m087
			;       RES0:
			;        W = 0;
m086	CLRW 
			;       ASSIGNW:
			;        arg1f24.low8 = W;
m087	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg1f24
			;        arg1f24.mid8 = W;
	MOVWF arg1f24+1
			;        arg1f24.high8 = W;
	MOVWF arg1f24+2
			;        arg1f24.23 = 0;
	BCF   arg1f24+2,7
			;    }
			;    else  {
	GOTO  m090
			;       #ifndef DISABLE_ROUNDING
			;        if (FpRounding && (xtra & 0x80))  {
m088	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x2F,FpRounding
	GOTO  m089
	BTFSS xtra_4,7
	GOTO  m089
			;            arg1f24.low8 += 1;
	INCF  arg1f24,1
			;            if (!arg1f24.low8)
	MOVF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m089
			;                arg1f24.mid8 += 1;
	INCF  arg1f24+1,1
			;        }
			;       #endif
			;        if (sign & 0x80)
m089	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS sign_6,7
	GOTO  m090
			;            arg1f24.low24 = -arg1f24.low24;
	COMF  arg1f24+2,1
	COMF  arg1f24+1,1
	COMF  arg1f24,1
	INCF  arg1f24,1
	BTFSS 0x03,Zero_
	GOTO  m090
	INCF  arg1f24+1,1
	BTFSC 0x03,Zero_
	INCF  arg1f24+2,1
			;    }
			;    int24 rval @ arg1f24;
			;    rval = arg1f24.low24;
			;    return rval;
m090	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  rval_3,W
	RETURN
			;}
			;
			;
			;bit operator< _f24_LT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_LT_f24
			;    Carry = 0;
			;    if (!(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if (!arg1f24.15)  {
			;        if (arg2f24.15)
			;            return Carry;
			;        W = arg1f24.low8 - arg2f24.low8;
			;        genSubW( arg1f24.mid8, arg2f24.mid8);
			;        genSubW( arg1f24.high8, arg2f24.high8);
			;        goto _RETURN_MF;
			;    }
			;    if (!arg2f24.15)
			;        goto _RETURN_MF;
			;    W = arg2f24.low8 - arg1f24.low8;
			;    genSubW( arg2f24.mid8, arg1f24.mid8);
			;    genSubW( arg2f24.high8, arg1f24.high8);
			;  _RETURN_MF:
			;    if (Carry)
			;        return 0;
			;    return 1;
			;}
			;
			;
			;bit operator>= _f24_GE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_GE_f24
			;    Carry = 1;
			;    if (!(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if (!arg1f24.15)  {
			;        if (arg2f24.15)
			;            return Carry;
			;        W = arg1f24.low8 - arg2f24.low8;
			;        genSubW( arg1f24.mid8, arg2f24.mid8);
			;        genSubW( arg1f24.high8, arg2f24.high8);
			;        return Carry;
			;    }
			;    Carry = 0;
			;    if (!arg2f24.15)
			;        return Carry;
			;    W = arg2f24.low8 - arg1f24.low8;
			;    genSubW( arg2f24.mid8, arg1f24.mid8);
			;    genSubW( arg2f24.high8, arg1f24.high8);
			;    return Carry;
			;}
			;
			;
			;
			;bit operator> _f24_GT_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_GT_f24
			;    Carry = 0;
			;    if (!(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if (!arg1f24.15)  {
			;        if (arg2f24.15)
			;            goto _RETURN_MF;
			;        W = arg2f24.low8 - arg1f24.low8;
			;        genSubW( arg2f24.mid8, arg1f24.mid8);
			;        genSubW( arg2f24.high8, arg1f24.high8);
			;        goto _RETURN_MF;
			;    }
			;    if (!arg2f24.15)
			;        return Carry;
			;    W = arg1f24.low8 - arg2f24.low8;
			;    genSubW( arg1f24.mid8, arg2f24.mid8);
			;    genSubW( arg1f24.high8, arg2f24.high8);
			;  _RETURN_MF:
			;    if (Carry)
			;        return 0;
			;    return 1;
			;}
			;
			;
			;
			;bit operator<= _f24_LE_f24( sharedM float24 arg1f24, sharedM float24 arg2f24)
			;{
_f24_LE_f24
			;    Carry = 1;
			;    if (!(arg1f24.high8 | arg2f24.high8))
			;        return Carry;
			;    if (!arg1f24.15)  {
			;        Carry = 0;
			;        if (arg2f24.15)
			;            return Carry;
			;        W = arg2f24.low8 - arg1f24.low8;
			;        genSubW( arg2f24.mid8, arg1f24.mid8);
			;        genSubW( arg2f24.high8, arg1f24.high8);
			;        return Carry;
			;    }
			;    if (!arg2f24.15)
			;        return Carry;
			;    W = arg1f24.low8 - arg2f24.low8;
			;    genSubW( arg1f24.mid8, arg2f24.mid8);
			;    genSubW( arg1f24.high8, arg2f24.high8);
			;    return Carry;

  ; FILE C:\Program Files\bknd\CC5X\MATH16.H
			;// SIZE
			;
			;#pragma library 1
			;/*
			;uns16 operator* _mult8x8( uns8 arg1, uns8 arg2);
			;int16 operator* _multS8x8( int8 arg1, int8 arg2);
			;uns16 operator* _multU16x8( uns16 arg1, uns8 arg2);
			;uns16 operator* _mult16x16( uns16 arg1, uns16 arg2);
			;uns16 operator/ _divU16_8( uns16 arg1, uns8 arg2);
			;uns16 operator/ _divU16_16( uns16 arg1, uns16 arg2);
			;int16 operator/ _divS16_8( int16 arg1, int8 arg2);
			;int16 operator/ _divS16_16( int16 arg1, int16 arg2);
			;uns8 operator% _remU16_8( uns16 arg1, uns8 arg2);
			;uns16 operator% _remU16_16( uns16 arg1, uns16 arg2);
			;int8 operator% _remS16_8( int16 arg1, int8 arg2);
			;int16 operator% _remS16_16( int16 arg1, int16 arg2);
			;*/
			;
			;#if __CoreSet__ < 1410
			; #define genAdd(r,a) W=a; btsc(Carry); W=incsz(a); r+=W
			; #define genSub(r,a) W=a; btss(Carry); W=incsz(a); r-=W
			; #define genAddW(r,a) W=a; btsc(Carry); W=incsz(a); W=r+W
			; #define genSubW(r,a) W=a; btss(Carry); W=incsz(a); W=r-W
			;#else
			; #define genAdd(r,a) W=a; r=addWFC(r)
			; #define genSub(r,a) W=a; r=subWFB(r)
			; #define genAddW(r,a) W=a; W=addWFC(r)
			; #define genSubW(r,a) W=a; W=subWFB(r)
			;#endif
			;
			;
			;int8 operator*( int8 arg1, int8 arg2)  @
			;
			;uns16 operator* _mult8x8( uns8 arg1, uns8 arg2)
			;{
_mult8x8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg2
			;    uns16 rval;
			;    char counter = sizeof(arg2)*8;
	MOVLW 8
	MOVWF counter_3
			;    rval.high8 = 0;
	CLRF  rval_4+1
			;    W = arg1;
	MOVF  arg1,W
			;    do  {
			;        arg2 = rr( arg2);
m091	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   arg2,1
			;        if (Carry)
	BTFSS 0x03,Carry
	GOTO  m092
			;            rval.high8 += W;
	ADDWF rval_4+1,1
			;        rval = rr( rval);
m092	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   rval_4+1,1
	RRF   rval_4,1
			;        counter = decsz(counter);
	DECFSZ counter_3,1
			;    } while (1);
	GOTO  m091
			;    return rval;
	MOVF  rval_4,W
	RETURN
			;}
			;
			;
			;int16 operator* _multS8x8( int8 arg1, int8 arg2)
			;{
_multS8x8
			;    uns16 rval;
			;    char counter = sizeof(arg2)*8;
			;    int8 tmpArg2 = arg2;
			;    rval.high8 = 0;
			;    W = arg1;
			;    do  {
			;        tmpArg2 = rr( tmpArg2);
			;        if (Carry)
			;            rval.high8 += W;
			;        rval = rr( rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    W = arg2;
			;    if (arg1 < 0)
			;        rval.high8 -= W;
			;    W = arg1;
			;    if (arg2 < 0)
			;        rval.high8 -= W;
			;    return rval;
			;}
			;
			;
			;uns16 operator*( uns8 arg1, uns16 arg2) exchangeArgs @
			;
			;uns16 operator* _multU16x8( uns16 arg1, uns8 arg2)
			;{
_multU16x8
			;    uns16 rval;
			;    uns8 rvalH = 0;
			;    char counter = sizeof(arg1)*8;
			;    W = arg2;
			;    do  {
			;        arg1 = rr( arg1);
			;        if (Carry)
			;            rvalH += W;
			;        rvalH = rr(rvalH);
			;        rval = rr(rval);
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;int16 operator*( int16 arg1, int16 arg2) @
			;
			;uns16 operator* _mult16x16( uns16 arg1, uns16 arg2)
			;{
_mult16x16
			;    uns16 rval;
			;    char counter = sizeof(arg1)*8;
			;    do  {
			;        Carry = 0;
			;        rval = rl( rval);
			;        arg1 = rl( arg1);
			;        if (Carry)
			;            rval += arg2;
			;        counter = decsz(counter);
			;    } while (1);
			;    return rval;
			;}
			;
			;
			;
			;uns16 operator/ _divU16_8( uns16 arg1, uns8 arg2)
			;{
_divU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg2_5
			;    uns8 rm = 0;
	CLRF  rm
			;    char counter = sizeof(arg1)*8+1;
	MOVLW 17
	MOVWF counter_7
			;    goto ENTRY_ML;
	GOTO  m095
			;    do  {
			;        rm = rl( rm);
m093	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   rm,1
			;        uns8 tmp = rl( tmp);
	RLF   tmp,1
			;        W = rm - arg2;
	MOVF  arg2_5,W
	SUBWF rm,W
			;        if (tmp&1)
	BTFSS tmp,0
	GOTO  m094
			;            Carry = 1;
	BSF   0x03,Carry
			;        if (Carry)
m094	BTFSS 0x03,Carry
	GOTO  m095
			;            rm = W;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF rm
			;       ENTRY_ML:
			;        arg1 = rl( arg1);
m095	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   arg1_5,1
	RLF   arg1_5+1,1
			;        counter = decsz(counter);
	DECFSZ counter_7,1
			;    } while (1);
	GOTO  m093
			;    return arg1;
	MOVF  arg1_5,W
	RETURN
			;}
			;
			;
			;uns16 operator/ _divU16_16( uns16 arg1, uns16 arg2)
			;{
_divU16_16
			;    uns16 rm = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  rm_2
	CLRF  rm_2+1
			;    char counter = sizeof(arg1)*8+1;
	MOVLW 17
	MOVWF counter_8
			;    goto ENTRY_ML;
	GOTO  m098
			;    do  {
			;        rm = rl( rm);
m096	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   rm_2,1
	RLF   rm_2+1,1
			;        W = rm.low8 - arg2.low8;
	MOVF  arg2_6,W
	SUBWF rm_2,W
			;        genSubW( rm.high8, arg2.high8);
	MOVF  arg2_6+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2_6+1,W
	SUBWF rm_2+1,W
			;        if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m097
			;            goto ENTRY_ML;
	GOTO  m098
			;        rm.high8 = W;
m097	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF rm_2+1
			;        rm.low8 -= arg2.low8;
	MOVF  arg2_6,W
	SUBWF rm_2,1
			;        Carry = 1;
	BSF   0x03,Carry
			;       ENTRY_ML:
			;        arg1 = rl( arg1);
m098	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   arg1_6,1
	RLF   arg1_6+1,1
			;        counter = decsz(counter);
	DECFSZ counter_8,1
			;    } while (1);
	GOTO  m096
			;    return arg1;
	MOVF  arg1_6,W
	RETURN
			;}
			;
			;
			;int8  operator/ (int8 arg1, int8 arg2) @
			;
			;int16 operator/ _divS16_8( int16 arg1, int8 arg2)
			;{
_divS16_8
			;    uns8 rm = 0;
			;    char counter = 16+1;
			;    char sign = arg1.high8 ^ arg2.high8;
			;    if (arg1 < 0)  {
			;       INVERT_ML:
			;        arg1 = -arg1;
			;        if (!counter)
			;            return arg1;
			;    }
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    goto ENTRY_ML;
			;    do  {
			;        rm = rl( rm);
			;        W = rm - arg2;
			;        if (Carry)
			;            rm = W;
			;       ENTRY_ML:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        goto INVERT_ML;
			;    return arg1;
			;}
			;
			;
			;int16 operator/ _divS16_16( int16 arg1, int16 arg2)
			;{
_divS16_16
			;    uns16 rm = 0;
			;    char counter = sizeof(arg1)*8+1;
			;    char sign = arg1.high8 ^ arg2.high8;
			;    if (arg1 < 0)  {
			;       INVERT_ML:
			;        arg1 = -arg1;
			;        if (!counter)
			;            return arg1;
			;    }
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    goto ENTRY_ML;
			;    do  {
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto ENTRY_ML;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;        Carry = 1;
			;       ENTRY_ML:
			;        arg1 = rl( arg1);
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        goto INVERT_ML;
			;    return arg1;
			;}
			;
			;
			;uns8 operator% _remU16_8( uns16 arg1, uns8 arg2)
			;{
_remU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg2_9
			;    uns8 rm = 0;
	CLRF  rm_5
			;    char counter = sizeof(arg1)*8;
	MOVLW 16
	MOVWF counter_11
			;    do  {
			;        arg1 = rl( arg1);
m099	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   arg1_9,1
	RLF   arg1_9+1,1
			;        rm = rl( rm);
	RLF   rm_5,1
			;        uns8 tmp = rl( tmp);
	RLF   tmp_2,1
			;        W = rm - arg2;
	MOVF  arg2_9,W
	SUBWF rm_5,W
			;        if (tmp&1)
	BTFSS tmp_2,0
	GOTO  m100
			;            Carry = 1;
	BSF   0x03,Carry
			;        if (Carry)
m100	BTFSS 0x03,Carry
	GOTO  m101
			;            rm = W;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF rm_5
			;        counter = decsz(counter);
m101	BCF   0x03,RP0
	BCF   0x03,RP1
	DECFSZ counter_11,1
			;    } while (1);
	GOTO  m099
			;    return rm;
	MOVF  rm_5,W
	RETURN
			;}
			;
			;
			;uns16 operator% _remU16_16( uns16 arg1, uns16 arg2)
			;{
_remU16_16
			;    uns16 rm = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  rm_6
	CLRF  rm_6+1
			;    char counter = sizeof(arg1)*8;
	MOVLW 16
	MOVWF counter_12
			;    do  {
			;        arg1 = rl( arg1);
m102	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   arg1_10,1
	RLF   arg1_10+1,1
			;        rm = rl( rm);
	RLF   rm_6,1
	RLF   rm_6+1,1
			;        W = rm.low8 - arg2.low8;
	MOVF  arg2_10,W
	SUBWF rm_6,W
			;        genSubW( rm.high8, arg2.high8);
	MOVF  arg2_10+1,W
	BTFSS 0x03,Carry
	INCFSZ arg2_10+1,W
	SUBWF rm_6+1,W
			;        if (!Carry)
	BTFSC 0x03,Carry
	GOTO  m103
			;            goto NOSUB;
	GOTO  m104
			;        rm.high8 = W;
m103	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF rm_6+1
			;        rm.low8 -= arg2.low8;
	MOVF  arg2_10,W
	SUBWF rm_6,1
			;      NOSUB:
			;        counter = decsz(counter);
m104	BCF   0x03,RP0
	BCF   0x03,RP1
	DECFSZ counter_12,1
			;    } while (1);
	GOTO  m102
			;    return rm;
	MOVF  rm_6,W
	RETURN
			;}
			;
			;
			;int8 operator% (int8 arg1, int8 arg2) @
			;
			;int8 operator% _remS16_8( int16 arg1, int8 arg2)
			;{
_remS16_8
			;    int8 rm = 0;
			;    char counter = 16;
			;    char sign = arg1.high8;
			;    if (arg1 < 0)
			;        arg1 = -arg1;
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm - arg2;
			;        if (Carry)
			;            rm = W;
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        rm = -rm;
			;    return rm;
			;}
			;
			;
			;int16 operator% _remS16_16( int16 arg1, int16 arg2)
			;{
_remS16_16
			;    int16 rm = 0;
			;    char counter = sizeof(arg1)*8;
			;    char sign = arg1.high8;
			;    if (arg1 < 0)
			;        arg1 = -arg1;
			;    if (arg2 < 0)
			;        arg2 = -arg2;
			;    do  {
			;        arg1 = rl( arg1);
			;        rm = rl( rm);
			;        W = rm.low8 - arg2.low8;
			;        genSubW( rm.high8, arg2.high8);
			;        if (!Carry)
			;            goto NOSUB;
			;        rm.high8 = W;
			;        rm.low8 -= arg2.low8;
			;      NOSUB:
			;        counter = decsz(counter);
			;    } while (1);
			;    if (sign & 0x80)
			;        rm = -rm;
			;    return rm;

  ; FILE header_anemo.h
			;#include "math24f.h"
			;#include "MATH16.H"
			;#pragma codepage 0
	ORG 0x0001

  ; FILE main.c
			;#include "header_anemo.h"
			;unsigned long temps,v,vmax,tampon,tampon2,nb_timer,var_temps;
			;unsigned long var_2s,moyenne_1,tab_10[10],moyenne10,moyenne_av1,moyenne_av2,moyenne_av3;
			;char v0,v1,v2,v3,v4,i,a,tmr,valid_it,var_tampon,h,bit_h_lect,bit_l_lect;
			;char i_1Min,i_tab,tampon_s;
			;float temps_ms,fl_temp;
			;//******************************************************************
			;//Programme d'interruption
			;#pragma origin 4
	ORG 0x0004
			;interrupt ils(void){
ils
			;	int_save_registers
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
	MOVF  PCLATH,W
	MOVWF svrPCLATH
	CLRF  PCLATH
			;	tmr=TMR0;
	MOVF  TMR0,W
	MOVWF tmr
			;	TMR0=3;
	MOVLW 3
	MOVWF TMR0
			;	if(TMR0IF){
	BTFSS 0x0B,TMR0IF
	GOTO  m106
			;		TMR0IF=0;
	BCF   0x0B,TMR0IF
			;		nb_timer++;
	INCF  nb_timer,1
	BTFSC 0x03,Zero_
	INCF  nb_timer+1,1
			;		var_2s++;
	INCF  var_2s,1
	BTFSC 0x03,Zero_
	INCF  var_2s+1,1
			;		if(nb_timer>TEMPS_MAX){
	MOVLW 234
	SUBWF nb_timer+1,W
	BTFSS 0x03,Carry
	GOTO  m106
	BTFSS 0x03,Zero_
	GOTO  m105
	MOVLW 97
	SUBWF nb_timer,W
	BTFSS 0x03,Carry
	GOTO  m106
			;			var_temps=TEMPS_MAX;
m105	MOVLW 96
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF var_temps
	MOVLW 234
	MOVWF var_temps+1
			;			nb_timer=TEMPS_MAX;
	MOVLW 96
	MOVWF nb_timer
	MOVLW 234
	MOVWF nb_timer+1
			;			if(valid_it==0){
	MOVF  valid_it,1
	BTFSS 0x03,Zero_
	GOTO  m106
			;				valid_it=1;
	MOVLW 1
	MOVWF valid_it
			;			}
			;		}
			;	
			;	}
			;	if(INT0IF){
m106	BTFSS 0x0B,INT0IF
	GOTO  m107
			;		INT0IF=0;
	BCF   0x0B,INT0IF
			;		var_temps=nb_timer;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  nb_timer,W
	MOVWF var_temps
	MOVF  nb_timer+1,W
	MOVWF var_temps+1
			;		var_tampon=tmr-2;
	MOVLW 2
	SUBWF tmr,W
	MOVWF var_tampon
			;		nb_timer=0;
	CLRF  nb_timer
	CLRF  nb_timer+1
			;		valid_it=1;
	MOVLW 1
	MOVWF valid_it
			;		PORT_DEL=!PORT_DEL;
	MOVLW 8
	XORWF PORTB,1
			;	}
			;	int_restore_registers
m107	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  svrPCLATH,W
	MOVWF PCLATH
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;#pragma sharedAllocation
			;//******************************************************************
			;
			;
			;
			;//******************************************************************
			;//Programme principal
			;void main(void){
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ci
	MOVLW 0
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   ci,W
	ANDLW 127
	ADDLW 111
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m108
	INCF  EEADRH,1
m108	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC ci,0
	GOTO  m109
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW 127
	RETURN
m109	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
	DW    0x1ED6
	DW    0x16AD
	DW    0x172D
	DW    0x25AD
	DW    0x17ED
	DW    0x68
	DW    0x1020
	DW    0x1030
	DW    0x3342
	DW    0x74
	DW    0x37CD
	DW    0x1EF9
	DW    0x16AD
	DW    0x172D
	DW    0x25AD
	DW    0x17ED
	DW    0x68
	DW    0x30CD
	DW    0x1EF8
	DW    0x16AD
	DW    0x172D
	DW    0x25AD
	DW    0x17ED
	DW    0x68
	DW    0x1020
	DW    0x1020
	DW    0x20
	DW    0x22D2
	DW    0x2647
	DW    0x23C1
	DW    0x1045
	DW    0x27C8
	DW    0x2652
	DW    0x23CF
	DW    0x1745
	DW    0x172E
	DW    0x2080
	DW    0x2850
	DW    0x2CD5
	DW    0x2D45
	DW    0x2820
	DW    0x2ACF
	DW    0x1052
	DW    0x2443
	DW    0x2741
	DW    0x22C7
	DW    0x52
	DW    0x22CC
	DW    0x1053
	DW    0x24CD
	DW    0x2ACE
	DW    0x22D4
	DW    0x53
	DW    0x1830
	DW    0x183A
	DW    0x30
	DW    0x22CC
	DW    0x1053
	DW    0x22C8
	DW    0x2955
	DW    0x29C5
	DW    0x20
	DW    0x3A
	DW    0x780
	DW    0x283
	DW    0x809
	DW    0x0
	DW    0x800
	DW    0x289
	DW    0x783
	DW    0x0
	DW    0x81F
	DW    0x810
	DW    0x810
	DW    0x1F
	DW    0x1F
	DW    0x0
	DW    0x0
	DW    0x1F
	DW    0x9F
	DW    0x81
	DW    0x81
	DW    0x1F
	DW    0xF9F
	DW    0xF9F
	DW    0xF9F
	DW    0x1F
main
			;	TRISA=0b00110000;
	MOVLW 48
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVWF TRISA
			;	ANSEL=0;
	CLRF  ANSEL
			;	PORT_DATA=0;
	BCF   0x03,RP0
	CLRF  PORTA
			;	TRISB=0b00000001;
	MOVLW 1
	BSF   0x03,RP0
	MOVWF TRISB
			;	PORTB=0;
	BCF   0x03,RP0
	CLRF  PORTB
			;	OPTION_REG=0b11000001; 		//front montant sur RB0 et TMR0=TCycle*4
	MOVLW 193
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	init_lcd();					//Initialisation du LCD
	CALL  init_lcd
			;	genere_car();				//Genere les caractres
	CALL  genere_car
			;	clear();
	CALL  clear
			;	tempo_l();
	CALL  tempo_l
			;	ecrire_donnee_horloge(105,0x90);	//Instruction de charge de la capa de sauvegarde
	MOVLW 105
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF data_h
	MOVLW 144
	CALL  ecrire_donnee_horloge
			;	if(BP_Horloge){				//Activation de la fonction criture de l'horloge si demand
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PORTA,4
	GOTO  m110
			;		ecrire_heure();
	CALL  ecrire_heure
			;		clear();
	CALL  clear
			;		tempo_l();
	CALL  tempo_l
			;	}
			;	// Lecture et affichage de l'heure
			;	affichage_heure(0x8F);
m110	MOVLW 143
	CALL  affichage_heure
			;	
			;	//Affichage des caractre ncessaire
			;	curseur(0x80);
	MOVLW 128
	CALL  curseur
			;	affich_chaine("V=---.-Km/h",11);//"---.-Km/h"
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  chaine
	MOVLW 11
	CALL  affich_chaine
			;	curseur(0xC0);
	MOVLW 192
	CALL  curseur
			;	affich_chiffre(210);
	MOVLW 210
	CALL  affich_chiffre
			;	for(h=0;h<10;h++){
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  h
m111	MOVLW 10
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF h,W
	BTFSC 0x03,Carry
	GOTO  m112
			;		affich_chiffre(211);		//Barre des Bfts
	MOVLW 211
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  h,1
	GOTO  m111
			;	affich_chiffre(212);
m112	MOVLW 212
	CALL  affich_chiffre
			;	affich_chaine("  0 Bft",7);
	MOVLW 12
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 7
	CALL  affich_chaine
			;	curseur(0x94);
	MOVLW 148
	CALL  curseur
			;	affich_chaine("Moy=---.-Km/h",13);
	MOVLW 20
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 13
	CALL  affich_chaine
			;	curseur(0xD4);
	MOVLW 212
	CALL  curseur
			;	affich_chaine("Max=---.-Km/h",13);
	MOVLW 34
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 13
	CALL  affich_chaine
			;	for (a=0;a<255;a++){
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  a
m113	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  a,W
	BTFSC 0x03,Zero_
	GOTO  m114
			;		tempo_l();
	CALL  tempo_l
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  a,1
	GOTO  m113
			;	for (a=0;a<255;a++){
m114	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  a
m115	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  a,W
	BTFSC 0x03,Zero_
	GOTO  m116
			;		tempo_l();
	CALL  tempo_l
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  a,1
	GOTO  m115
			;
			;	//Initialisation des variables
			;	TMR0=0;
m116	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  TMR0
			;	var_2s=0;
	CLRF  var_2s
	CLRF  var_2s+1
			;	vmax=0;
	CLRF  vmax
	CLRF  vmax+1
			;	valid_it=1;
	MOVLW 1
	MOVWF valid_it
			;	nb_timer=TEMPS_MAX;
	MOVLW 96
	MOVWF nb_timer
	MOVLW 234
	MOVWF nb_timer+1
			;	var_temps=TEMPS_MAX;
	MOVLW 96
	MOVWF var_temps
	MOVLW 234
	MOVWF var_temps+1
			;	i_1Min=0;
	CLRF  i_1Min
			;	i_tab=0;
	CLRF  i_tab
			;	moyenne_1=0;
	CLRF  moyenne_1
	CLRF  moyenne_1+1
			;	moyenne_av3=0;
	CLRF  moyenne_av3
	CLRF  moyenne_av3+1
			;	moyenne_av2=0;
	CLRF  moyenne_av2
	CLRF  moyenne_av2+1
			;	moyenne_av1=0;
	CLRF  moyenne_av1
	CLRF  moyenne_av1+1
			;	moyenne10=0;
	CLRF  moyenne10
	CLRF  moyenne10+1
			;	for(i=0;i<10;i++){
	CLRF  i
m117	MOVLW 10
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m118
			;		tab_10[i]=0;
	BCF   0x03,Carry
	RLF   i,W
	ADDLW 66
	MOVWF FSR
	BCF   0x03,IRP
	CLRF  INDF
	INCF  FSR,1
	CLRF  INDF
			;	}
	INCF  i,1
	GOTO  m117
			;
			;	INTCON=0b10110000;// Validation des interruption, sur RB0 et TMR0
m118	MOVLW 176
	MOVWF INTCON
			;	for(;;){
			;		if(valid_it==1){
m119	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  valid_it,W
	BTFSS 0x03,Zero_
	GOTO  m125
			;			//Calcul de la vitesse	
			;			temps_ms=(float)var_temps*0.2048; //Temps en ms
	MOVF  var_temps,W
	MOVWF arg1f24
	MOVF  var_temps+1,W
	MOVWF arg1f24+1
	CLRF  arg1f24+2
	BSF   0x0A,PA0
	CALL  _int24ToFloat24
	BCF   0x0A,PA0
	MOVLW 183
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg2f24
	MOVLW 81
	MOVWF arg2f24+1
	MOVLW 124
	MOVWF arg2f24+2
	BSF   0x0A,PA0
	CALL  _fmul24
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	MOVWF temps_ms
	MOVF  arg1f24+1,W
	MOVWF temps_ms+1
	MOVF  arg1f24+2,W
	MOVWF temps_ms+2
			;			tampon_s=var_tampon-3;
	MOVLW 3
	SUBWF var_tampon,W
	MOVWF tampon_s
			;			fl_temp=tampon_s*0.00080314;// calcul des diximes de milliseconde
	MOVF  tampon_s,W
	MOVWF arg1f24
	CLRF  arg1f24+1
	CLRF  arg1f24+2
	BSF   0x0A,PA0
	CALL  _int24ToFloat24
	BCF   0x0A,PA0
	MOVLW 138
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF arg2f24
	MOVLW 82
	MOVWF arg2f24+1
	MOVLW 116
	MOVWF arg2f24+2
	BSF   0x0A,PA0
	CALL  _fmul24
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	MOVWF fl_temp
	MOVF  arg1f24+1,W
	MOVWF fl_temp+1
	MOVF  arg1f24+2,W
	MOVWF fl_temp+2
			;			fl_temp+=temps_ms;
	MOVF  fl_temp,W
	MOVWF arg1f24
	MOVF  fl_temp+1,W
	MOVWF arg1f24+1
	MOVF  fl_temp+2,W
	MOVWF arg1f24+2
	MOVF  temps_ms,W
	MOVWF arg2f24
	MOVF  temps_ms+1,W
	MOVWF arg2f24+1
	MOVF  temps_ms+2,W
	MOVWF arg2f24+2
	BSF   0x0A,PA0
	CALL  _fadd24
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	MOVWF fl_temp
	MOVF  arg1f24+1,W
	MOVWF fl_temp+1
	MOVF  arg1f24+2,W
	MOVWF fl_temp+2
			;			fl_temp=11309.8/fl_temp;
	MOVLW 183
	MOVWF arg1f24
	MOVLW 48
	MOVWF arg1f24+1
	MOVLW 140
	MOVWF arg1f24+2
	MOVF  fl_temp,W
	MOVWF arg2f24
	MOVF  fl_temp+1,W
	MOVWF arg2f24+1
	MOVF  fl_temp+2,W
	MOVWF arg2f24+2
	BSF   0x0A,PA0
	CALL  _fdiv24
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1f24,W
	MOVWF fl_temp
	MOVF  arg1f24+1,W
	MOVWF fl_temp+1
	MOVF  arg1f24+2,W
	MOVWF fl_temp+2
			;			v=fl_temp;
	MOVF  fl_temp,W
	MOVWF arg1f24
	MOVF  fl_temp+1,W
	MOVWF arg1f24+1
	MOVF  fl_temp+2,W
	MOVWF arg1f24+2
	BSF   0x0A,PA0
	CALL  _float24ToInt24
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  rval_3,W
	MOVWF v
	MOVF  rval_3+1,W
	MOVWF v+1
			;			affichage_vitesse(0x82,v);
	MOVLW 130
	MOVWF position
	MOVF  v,W
	MOVWF v_affich
	MOVF  v+1,W
	MOVWF v_affich+1
	CALL  affichage_vitesse
			;
			;			if(v>=vmax){
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  vmax+1,W
	SUBWF v+1,W
	BTFSS 0x03,Carry
	GOTO  m121
	BTFSS 0x03,Zero_
	GOTO  m120
	MOVF  vmax,W
	SUBWF v,W
	BTFSS 0x03,Carry
	GOTO  m121
			;				vmax=v;
m120	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v,W
	MOVWF vmax
	MOVF  v+1,W
	MOVWF vmax+1
			;				affichage_vitesse(0xD8,vmax);
	MOVLW 216
	MOVWF position
	MOVF  vmax,W
	MOVWF v_affich
	MOVF  vmax+1,W
	MOVWF v_affich+1
	CALL  affichage_vitesse
			;				affichage_heure(0xE3);
	MOVLW 227
	CALL  affichage_heure
			;			}
			;
			;			if(var_temps>=TEMPS_MAX) {	//Empeche le retour dans la boucle si V=0
m121	MOVLW 234
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF var_temps+1,W
	BTFSS 0x03,Carry
	GOTO  m123
	BTFSS 0x03,Zero_
	GOTO  m122
	MOVLW 96
	SUBWF var_temps,W
	BTFSS 0x03,Carry
	GOTO  m123
			;				valid_it=3;
m122	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF valid_it
			;			}
			;			else{					//Empeche le retour dans la boucle
	GOTO  m124
			;				valid_it=0;
m123	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  valid_it
			;			}
			;
			;			echelle_bft(v);
m124	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v,W
	MOVWF v_comp
	MOVF  v+1,W
	MOVWF v_comp+1
	BSF   0x0A,PA0
	CALL  echelle_bft
	BCF   0x0A,PA0
			;		}// Fin du traitement d'interruption sur la vitesse.
			;
			;
			;		if(var_2s>9730){
m125	MOVLW 38
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF var_2s+1,W
	BTFSS 0x03,Carry
	GOTO  m146
	BTFSS 0x03,Zero_
	GOTO  m126
	MOVLW 3
	SUBWF var_2s,W
	BTFSS 0x03,Carry
	GOTO  m146
			;			PORT_2S=!PORT_2S;
m126	MOVLW 16
	BCF   0x03,RP0
	BCF   0x03,RP1
	XORWF PORTB,1
			;			var_2s=0;
	CLRF  var_2s
	CLRF  var_2s+1
			;			moyenne_1+=v;		
	MOVF  v+1,W
	ADDWF moyenne_1+1,1
	MOVF  v,W
	ADDWF moyenne_1,1
	BTFSC 0x03,Carry
	INCF  moyenne_1+1,1
			;			i_1Min++;
	INCF  i_1Min,1
			;			if(i_1Min==30){
	MOVF  i_1Min,W
	XORLW 30
	BTFSS 0x03,Zero_
	GOTO  m146
			;				i_1Min=0;
	CLRF  i_1Min
			;				moyenne_1/=30;
	MOVF  moyenne_1,W
	MOVWF arg1_5
	MOVF  moyenne_1+1,W
	MOVWF arg1_5+1
	MOVLW 30
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	MOVWF moyenne_1
	MOVF  arg1_5+1,W
	MOVWF moyenne_1+1
			;				tab_10[i_tab]=moyenne_1;
	BCF   0x03,Carry
	RLF   i_tab,W
	ADDLW 66
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  moyenne_1,W
	MOVWF INDF
	INCF  FSR,1
	MOVF  moyenne_1+1,W
	MOVWF INDF
			;				moyenne_1=0;
	CLRF  moyenne_1
	CLRF  moyenne_1+1
			;				if(i_tab==9){i_tab=0;}
	MOVF  i_tab,W
	XORLW 9
	BTFSS 0x03,Zero_
	GOTO  m127
	CLRF  i_tab
			;				else{i_tab++;}
	GOTO  m128
m127	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_tab,1
			;				tampon=0;
m128	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  tampon
	CLRF  tampon+1
			;				for(i=0;i<10;i++){
	CLRF  i
m129	MOVLW 10
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m130
			;					tampon2=tab_10[i];
	BCF   0x03,Carry
	RLF   i,W
	ADDLW 66
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	MOVWF tampon2
	INCF  FSR,1
	MOVF  INDF,W
	MOVWF tampon2+1
			;					tampon+=tampon2;
	MOVF  tampon2+1,W
	ADDWF tampon+1,1
	MOVF  tampon2,W
	ADDWF tampon,1
	BTFSC 0x03,Carry
	INCF  tampon+1,1
			;				}
	INCF  i,1
	GOTO  m129
			;				moyenne_av3=moyenne_av2;
m130	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  moyenne_av2,W
	MOVWF moyenne_av3
	MOVF  moyenne_av2+1,W
	MOVWF moyenne_av3+1
			;				moyenne_av2=moyenne_av1;
	MOVF  moyenne_av1,W
	MOVWF moyenne_av2
	MOVF  moyenne_av1+1,W
	MOVWF moyenne_av2+1
			;				moyenne_av1=moyenne10;
	MOVF  moyenne10,W
	MOVWF moyenne_av1
	MOVF  moyenne10+1,W
	MOVWF moyenne_av1+1
			;				moyenne10=tampon/10;
	MOVF  tampon,W
	MOVWF arg1_5
	MOVF  tampon+1,W
	MOVWF arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	MOVWF moyenne10
	MOVF  arg1_5+1,W
	MOVWF moyenne10+1
			;				tampon_s=3;
	MOVLW 3
	MOVWF tampon_s
			;				if(moyenne_av2>moyenne_av3){
	MOVF  moyenne_av2+1,W
	SUBWF moyenne_av3+1,W
	BTFSS 0x03,Carry
	GOTO  m131
	BTFSS 0x03,Zero_
	GOTO  m132
	MOVF  moyenne_av2,W
	SUBWF moyenne_av3,W
	BTFSC 0x03,Carry
	GOTO  m132
			;					tampon_s++;
m131	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  tampon_s,1
			;				}
			;				else if(moyenne_av2<moyenne_av3){
	GOTO  m134
m132	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  moyenne_av3+1,W
	SUBWF moyenne_av2+1,W
	BTFSS 0x03,Carry
	GOTO  m133
	BTFSS 0x03,Zero_
	GOTO  m134
	MOVF  moyenne_av3,W
	SUBWF moyenne_av2,W
	BTFSC 0x03,Carry
	GOTO  m134
			;					tampon_s--;
m133	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  tampon_s,1
			;				}
			;				if(moyenne_av1>moyenne_av2){
m134	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  moyenne_av1+1,W
	SUBWF moyenne_av2+1,W
	BTFSS 0x03,Carry
	GOTO  m135
	BTFSS 0x03,Zero_
	GOTO  m136
	MOVF  moyenne_av1,W
	SUBWF moyenne_av2,W
	BTFSC 0x03,Carry
	GOTO  m136
			;					tampon_s++;
m135	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  tampon_s,1
			;				}
			;				else if(moyenne_av1<moyenne_av2){
	GOTO  m138
m136	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  moyenne_av2+1,W
	SUBWF moyenne_av1+1,W
	BTFSS 0x03,Carry
	GOTO  m137
	BTFSS 0x03,Zero_
	GOTO  m138
	MOVF  moyenne_av2,W
	SUBWF moyenne_av1,W
	BTFSC 0x03,Carry
	GOTO  m138
			;					tampon_s--;
m137	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  tampon_s,1
			;				}
			;				if(moyenne10>moyenne_av1){
m138	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  moyenne10+1,W
	SUBWF moyenne_av1+1,W
	BTFSS 0x03,Carry
	GOTO  m139
	BTFSS 0x03,Zero_
	GOTO  m140
	MOVF  moyenne10,W
	SUBWF moyenne_av1,W
	BTFSC 0x03,Carry
	GOTO  m140
			;					tampon_s++;
m139	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  tampon_s,1
			;					}
			;				else if(moyenne10<moyenne_av1){
	GOTO  m142
m140	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  moyenne_av1+1,W
	SUBWF moyenne10+1,W
	BTFSS 0x03,Carry
	GOTO  m141
	BTFSS 0x03,Zero_
	GOTO  m142
	MOVF  moyenne_av1,W
	SUBWF moyenne10,W
	BTFSC 0x03,Carry
	GOTO  m142
			;					tampon_s--;
m141	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  tampon_s,1
			;				}
			;				curseur(0xA3);
m142	MOVLW 163
	CALL  curseur
			;				if(tampon_s>4){
	MOVLW 5
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF tampon_s,W
	BTFSS 0x03,Carry
	GOTO  m143
			;					affich_chiffre(208);
	MOVLW 208
	CALL  affich_chiffre
			;				}
			;				else if(tampon_s<2){
	GOTO  m145
m143	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF tampon_s,W
	BTFSC 0x03,Carry
	GOTO  m144
			;					affich_chiffre(209);
	MOVLW 209
	CALL  affich_chiffre
			;				}
			;				else{
	GOTO  m145
			;					affich_chiffre(0x7E-48);
m144	MOVLW 78
	CALL  affich_chiffre
			;				}
			;				affichage_vitesse(0x98,moyenne10);
m145	MOVLW 152
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF position
	MOVF  moyenne10,W
	MOVWF v_affich
	MOVF  moyenne10+1,W
	MOVWF v_affich+1
	CALL  affichage_vitesse
			;				//Lecture de l'heure
			;				affichage_heure(0x8F);
	MOVLW 143
	CALL  affichage_heure
			;	
			;			}//Moyenne sur 1min
			;		}//Fin moyenne
			;		if(BP_Gene){
m146	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PORTA,5
	GOTO  m147
			;			vmax=0;
	CLRF  vmax
	CLRF  vmax+1
			;			affichage_vitesse(0xD8,vmax);
	MOVLW 216
	MOVWF position
	MOVF  vmax,W
	MOVWF v_affich
	MOVF  vmax+1,W
	MOVWF v_affich+1
	CALL  affichage_vitesse
			;			curseur(0xE3);
	MOVLW 227
	CALL  curseur
			;			affich_chaine("     ",5);
	MOVLW 48
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 5
	CALL  affich_chaine
			;		}
			;	}// Fin for
m147	GOTO  m119
			;}// Fin Main
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;
			;// Temporisation courte 40s
			;void tempo_c(void){
tempo_c
			;	for(i=0;i<20;i++);
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m148	MOVLW 20
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m149
	INCF  i,1
	GOTO  m148
			;}
m149	RETURN
			;
			;//Tempo pour clignotement des heures et autres...
			;void tempo_longue(void){
tempo_longue
			;	for(h=0;h<200;h++){
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  h
m150	MOVLW 200
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF h,W
	BTFSC 0x03,Carry
	GOTO  m151
			;		tempo_l();
	CALL  tempo_l
			;		tempo_l();
	CALL  tempo_l
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  h,1
	GOTO  m150
			;}
m151	RETURN
			;
			;// Temporisation longue 1.64 ms
			;void tempo_l(void){
tempo_l
			;	for(i=0;i<255;i++);
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m152	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i,W
	BTFSC 0x03,Zero_
	GOTO  m153
	INCF  i,1
	GOTO  m152
			;	for(i=0;i<255;i++);
m153	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m154	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i,W
	BTFSC 0x03,Zero_
	GOTO  m155
	INCF  i,1
	GOTO  m154
			;	for(i=0;i<255;i++);
m155	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m156	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i,W
	BTFSC 0x03,Zero_
	GOTO  m157
	INCF  i,1
	GOTO  m156
			;	for(i=0;i<255;i++);
m157	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m158	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i,W
	BTFSC 0x03,Zero_
	GOTO  m159
	INCF  i,1
	GOTO  m158
			;}
m159	RETURN
			;
			;// Impulsion E pour l'envoie de donnes 
			;void impuls(void){
impuls
			;	PORT_E=1;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   PORTB,2
			;	nop();
	NOP  
			;	nop();
	NOP  
			;	nop();
	NOP  
			;	PORT_E=0;
	BCF   PORTB,2
			;	tempo_c();
	GOTO  tempo_c
			;}
			;
			;//Affiche une cane de caractre
			;void affich_chaine(const char * chaine,char nb){
affich_chaine
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF nb
			;char count;
			;for(count=0;count<nb;count++)
	CLRF  count
m160	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  nb,W
	SUBWF count,W
	BTFSC 0x03,Carry
	GOTO  m161
			;	{
			;	char tempon;
			;	tempon=chaine[count];
	MOVF  count,W
	ADDWF chaine,W
	CALL  _const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tempon
			;	PORT_DATA=tempon>>4;
	SWAPF tempon,W
	ANDLW 15
	MOVWF PORTA
			;	impuls();
	CALL  impuls
			;	PORT_DATA=chaine[count];
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  count,W
	ADDWF chaine,W
	CALL  _const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;	impuls();
	CALL  impuls
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  count,1
	GOTO  m160
			;}
m161	RETURN
			;//Affiche un chiffre
			;void affich_chiffre(char chiff){
affich_chiffre
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chiff
			;chiff=chiff+48;
	MOVLW 48
	ADDWF chiff,1
			;PORT_DATA=chiff>>4;
	SWAPF chiff,W
	ANDLW 15
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=chiff;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  chiff,W
	MOVWF PORTA
			;impuls();
	GOTO  impuls
			;}
			;
			;//Efface l'cran	
			;void clear(void){
clear
			;PORT_RS=0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   PORTB,1
			;PORT_DATA=0;
	CLRF  PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=1;
	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;tempo_l();
	CALL  tempo_l
			;PORT_RS=1;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   PORTB,1
			;curseur(0x80);
	MOVLW 128
	GOTO  curseur
			;}
			;
			;
			;//Position le curseur dans la RAM/CG-RAM
			;void curseur(char place){
curseur
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF place
			;char temp;
			;temp=place;
	MOVF  place,W
	MOVWF temp_2
			;PORT_RS=0;
	BCF   PORTB,1
			;PORT_DATA=place>>4;
	SWAPF place,W
	ANDLW 15
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=temp;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  temp_2,W
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;PORT_RS=1;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   PORTB,1
			;}
	RETURN
			;
			;//Initialisation du LCD
			;void init_lcd(void){
init_lcd
			;for(a=0;a<255;a++){//On attend que le LCD s'allume
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  a
m162	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  a,W
	BTFSC 0x03,Zero_
	GOTO  m163
			;	tempo_l();
	CALL  tempo_l
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  a,1
	GOTO  m162
			;PORT_DATA=3;//mode 8 bits
m163	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=3;//mode 8 bits
	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=3;//mode 8 bits
	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=2;//mode 4 bits
	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=2;//mode 4 bits + 1 ligne + caractre 5*7
	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=8;
	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=0;//allumage affichage + cache curseur
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=12;
	MOVLW 12
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=0;//le curseur bouge vers la droite
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=4;
	MOVLW 4
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_DATA=0;//Incrmentation du curseur a chaque nouvelle donne
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;impuls();
	CALL  impuls
			;PORT_DATA=6;
	MOVLW 6
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF PORTA
			;impuls();
	CALL  impuls
			;
			;PORT_RS=1;//On passe en mode "donnes"
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   PORTB,1
			;clear();
	CALL  clear
			;tempo_l();
	GOTO  tempo_l
			;}
			;
			;//Affichage d'une vitesse "v_affich"
			;void affichage_vitesse(unsigned position,unsigned long v_affich){
affichage_vitesse
			;	curseur(position);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  position,W
	CALL  curseur
			;	v1=v_affich/1000;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v_affich,W
	MOVWF arg1_6
	MOVF  v_affich+1,W
	MOVWF arg1_6+1
	MOVLW 232
	MOVWF arg2_6
	MOVLW 3
	MOVWF arg2_6+1
	BSF   0x0A,PA0
	CALL  _divU16_16
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_6,W
	MOVWF v1
			;	tampon=v_affich%1000;
	MOVF  v_affich,W
	MOVWF arg1_10
	MOVF  v_affich+1,W
	MOVWF arg1_10+1
	MOVLW 232
	MOVWF arg2_10
	MOVLW 3
	MOVWF arg2_10+1
	BSF   0x0A,PA0
	CALL  _remU16_16
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  rm_6,W
	MOVWF tampon
	MOVF  rm_6+1,W
	MOVWF tampon+1
			;	v2=tampon/100;
	MOVF  tampon,W
	MOVWF arg1_5
	MOVF  tampon+1,W
	MOVWF arg1_5+1
	MOVLW 100
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	MOVWF v2
			;	tampon=v_affich%100;
	MOVF  v_affich,W
	MOVWF arg1_9
	MOVF  v_affich+1,W
	MOVWF arg1_9+1
	MOVLW 100
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tampon
	CLRF  tampon+1
			;	v3=tampon/10;
	MOVF  tampon,W
	MOVWF arg1_5
	MOVF  tampon+1,W
	MOVWF arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	MOVWF v3
			;	v4=v_affich%10;
	MOVF  v_affich,W
	MOVWF arg1_9
	MOVF  v_affich+1,W
	MOVWF arg1_9+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF v4
			;	if(v1==0){
	MOVF  v1,1
	BTFSS 0x03,Zero_
	GOTO  m164
			;		v1=112;
	MOVLW 112
	MOVWF v1
			;	}
			;	if(v2==0){
m164	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v2,1
	BTFSS 0x03,Zero_
	GOTO  m165
			;		v2=112;
	MOVLW 112
	MOVWF v2
			;	}
			;	affich_chiffre(v1);
m165	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v1,W
	CALL  affich_chiffre
			;	affich_chiffre(v2);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v2,W
	CALL  affich_chiffre
			;	affich_chiffre(v3);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v3,W
	CALL  affich_chiffre
			;	curseur(position+4);
	MOVLW 4
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF position,W
	CALL  curseur
			;	affich_chiffre(v4);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v4,W
	GOTO  affich_chiffre
			;}
			;
			;void ecrire_heure(void){
ecrire_heure
			;	unsigned heure_h,minute_h;
			;	unsigned adresse;
			;	curseur(0x80);
	MOVLW 128
	CALL  curseur
			;	affich_chaine("REGLAGE HORLOGE...",18);
	MOVLW 54
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 18
	CALL  affich_chaine
			;	curseur(0xC0);
	MOVLW 192
	CALL  curseur
			;	affich_chaine("APPUYEZ POUR CHANGER",20);
	MOVLW 73
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 20
	CALL  affich_chaine
			;	curseur(0x94);
	MOVLW 148
	CALL  curseur
			;	affich_chaine("LES MINUTES",11);
	MOVLW 94
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 11
	CALL  affich_chaine
			;	curseur(0xD4);
	MOVLW 212
	CALL  curseur
			;	affich_chaine("00:00",5);
	MOVLW 106
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 5
	CALL  affich_chaine
			;	while(!PORTA.5){
m166	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC PORTA,5
	GOTO  m167
			;		curseur(0xD7);
	MOVLW 215
	CALL  curseur
			;		affich_chaine("  ",2);
	MOVLW 51
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 2
	CALL  affich_chaine
			;		tempo_longue();
	CALL  tempo_longue
			;		curseur(0xD7);
	MOVLW 215
	CALL  curseur
			;		affich_chaine("00",2);
	MOVLW 109
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 2
	CALL  affich_chaine
			;		tempo_longue();
	CALL  tempo_longue
			;	}
	GOTO  m166
			;	minute_h=255;
m167	MOVLW 255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF minute_h
			;	heure_h=255;
	MOVLW 255
	MOVWF heure_h
			;	while(PORTA.5){
m168	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PORTA,5
	GOTO  m170
			;		minute_h++;
	INCF  minute_h,1
			;		curseur(0xD7);
	MOVLW 215
	CALL  curseur
			;		affich_chiffre(minute_h/10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  minute_h,W
	MOVWF arg1_5
	CLRF  arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	CALL  affich_chiffre
			;		affich_chiffre(minute_h%10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  minute_h,W
	MOVWF arg1_9
	CLRF  arg1_9+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	CALL  affich_chiffre
			;		if(minute_h==59){minute_h=0;}
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  minute_h,W
	XORLW 59
	BTFSS 0x03,Zero_
	GOTO  m169
	CLRF  minute_h
			;		tempo_longue();	
m169	CALL  tempo_longue
			;	}
	GOTO  m168
			;	curseur(0x94);
m170	MOVLW 148
	CALL  curseur
			;	affich_chaine("LES HEURES ",11);
	MOVLW 112
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 11
	CALL  affich_chaine
			;	while(!PORTA.5){
m171	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC PORTA,5
	GOTO  m172
			;		curseur(0xD4);
	MOVLW 212
	CALL  curseur
			;		affich_chaine("  ",2);
	MOVLW 51
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 2
	CALL  affich_chaine
			;		tempo_longue();
	CALL  tempo_longue
			;		curseur(0xD4);
	MOVLW 212
	CALL  curseur
			;		affich_chaine("00",2);
	MOVLW 109
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 2
	CALL  affich_chaine
			;		tempo_longue();
	CALL  tempo_longue
			;	}
	GOTO  m171
			;	while(PORTA.5){
m172	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS PORTA,5
	GOTO  m174
			;		heure_h++;
	INCF  heure_h,1
			;		curseur(0xD4);
	MOVLW 212
	CALL  curseur
			;		affich_chiffre(heure_h/10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  heure_h,W
	MOVWF arg1_5
	CLRF  arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	CALL  affich_chiffre
			;		affich_chiffre(heure_h%10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  heure_h,W
	MOVWF arg1_9
	CLRF  arg1_9+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	CALL  affich_chiffre
			;		if(heure_h==24){heure_h=0;}
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  heure_h,W
	XORLW 24
	BTFSS 0x03,Zero_
	GOTO  m173
	CLRF  heure_h
			;		tempo_longue();	
m173	CALL  tempo_longue
			;	}
	GOTO  m172
			;	ecrire_donnee_horloge(0,0x80);			//ecriture des secondes
m174	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  data_h
	MOVLW 128
	CALL  ecrire_donnee_horloge
			;	ecrire_donnee_horloge(minute_h,0x82);	//ecriture des minutes
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  minute_h,W
	MOVWF data_h
	MOVLW 130
	CALL  ecrire_donnee_horloge
			;	ecrire_donnee_horloge(heure_h,0x84);	//ecriture des heures
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  heure_h,W
	MOVWF data_h
	MOVLW 132
	GOTO  ecrire_donnee_horloge
			;}//fin reglage_heure
			;
			;
			;
			;
			;
			;
			;void ecrire_donnee_horloge(unsigned data_h,unsigned adresse_ecriture)
			;{
ecrire_donnee_horloge
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adresse_ecriture
			;	unsigned bit_h_ecr;
			;	unsigned bit_l_ecr;
			;	bit_h_ecr=data_h/10;	
	MOVF  data_h,W
	MOVWF arg1_5
	CLRF  arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	MOVWF bit_h_ecr
			;	bit_l_ecr=data_h%10;
	MOVF  data_h,W
	MOVWF arg1_9
	CLRF  arg1_9+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF bit_l_ecr
			;	data_h=bit_h_ecr;
	MOVF  bit_h_ecr,W
	MOVWF data_h
			;	data_h<<=4;
	SWAPF data_h,W
	ANDLW 240
	MOVWF data_h
			;	data_h=bit_l_ecr+data_h;
	MOVF  bit_l_ecr,W
	ADDWF data_h,1
			;	TRISB.7=0;
	BSF   0x03,RP0
	BCF   TRISB,7
			;	nop();
	NOP  
			;	PORTB.7=0;
	BCF   0x03,RP0
	BCF   PORTB,7
			;	nop();
	NOP  
			;	PORTB.6=0;
	BCF   PORTB,6
			;	nop();
	NOP  
			;	PORTB.5=0;
	BCF   PORTB,5
			;	nop();
	NOP  
			;	nop();
	NOP  
			;	PORTB.5=1;
	BSF   PORTB,5
			;	for(i=0;i<8;i++){
	CLRF  i
m175	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m176
			;		PORTB.6=0;
	BCF   PORTB,6
			;		PORTB.7=adresse_ecriture.0;
	BTFSS adresse_ecriture,0
	BCF   PORTB,7
	BTFSC adresse_ecriture,0
	BSF   PORTB,7
			;		nop();
	NOP  
			;		PORTB.6=1;
	BSF   PORTB,6
			;		adresse_ecriture=adresse_ecriture>>1;
	BCF   0x03,Carry
	RRF   adresse_ecriture,1
			;	}
	INCF  i,1
	GOTO  m175
			;	for(i=0;i<8;i++){
m176	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m177	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m178
			;		PORTB.6=0;
	BCF   PORTB,6
			;		PORTB.7=data_h.0;
	BTFSS data_h,0
	BCF   PORTB,7
	BTFSC data_h,0
	BSF   PORTB,7
			;		nop();
	NOP  
			;		PORTB.6=1;
	BSF   PORTB,6
			;		data_h=data_h>>1;
	BCF   0x03,Carry
	RRF   data_h,1
			;	}
	INCF  i,1
	GOTO  m177
			;	PORTB&=0b00011111; //Mise  zro de Rb7 Rb6 Rb5
m178	MOVLW 31
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF PORTB,1
			;	
			;}
	RETURN
			;	
			;void lecture_donnee_horloge(char adresse_lecture)
			;{
lecture_donnee_horloge
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adresse_lecture
			;	TRISB.7=0;
	BSF   0x03,RP0
	BCF   TRISB,7
			;	PORTB.7=0;
	BCF   0x03,RP0
	BCF   PORTB,7
			;	PORTB.6=0;
	BCF   PORTB,6
			;	PORTB.5=0;
	BCF   PORTB,5
			;	PORTB.5=1;
	BSF   PORTB,5
			;	for(i=0;i<8;i++){
	CLRF  i
m179	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m180
			;		PORTB.6=0;
	BCF   PORTB,6
			;		PORTB.7=adresse_lecture.0;
	BTFSS adresse_lecture,0
	BCF   PORTB,7
	BTFSC adresse_lecture,0
	BSF   PORTB,7
			;		PORTB.6=1;
	BSF   PORTB,6
			;		adresse_lecture=adresse_lecture>>1;
	BCF   0x03,Carry
	RRF   adresse_lecture,1
			;	}
	INCF  i,1
	GOTO  m179
			;	TRISB.7=1;
m180	BSF   0x03,RP0
	BCF   0x03,RP1
	BSF   TRISB,7
			;	PORTB.6=0;
	BCF   0x03,RP0
	BCF   PORTB,6
			;	tampon_s.7=PORTB.7;
	BCF   tampon_s,7
	BTFSC PORTB,7
	BSF   tampon_s,7
			;	for(i=0;i<7;i++){
	CLRF  i
m181	MOVLW 7
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m182
			;		PORTB.6=1;
	BSF   PORTB,6
			;		tampon_s>>=1;
	BCF   0x03,Carry
	RRF   tampon_s,1
			;		PORTB.6=0;
	BCF   PORTB,6
			;		tampon_s.7=PORTB.7;
	BCF   tampon_s,7
	BTFSC PORTB,7
	BSF   tampon_s,7
			;	}
	INCF  i,1
	GOTO  m181
			;	bit_l_lect=0b00001111&tampon_s;
m182	MOVLW 15
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF tampon_s,W
	MOVWF bit_l_lect
			;	bit_h_lect=0b01110000&tampon_s;
	MOVLW 112
	ANDWF tampon_s,W
	MOVWF bit_h_lect
			;	bit_h_lect>>=4;
	SWAPF bit_h_lect,W
	ANDLW 15
	MOVWF bit_h_lect
			;	bit_h_lect=bit_h_lect*10;
	MOVF  bit_h_lect,W
	MOVWF arg1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _mult8x8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  rval_4,W
	MOVWF bit_h_lect
			;	tampon_s=bit_h_lect+bit_l_lect;
	MOVF  bit_l_lect,W
	ADDWF bit_h_lect,W
	MOVWF tampon_s
			;	TRISB.7=0;
	BSF   0x03,RP0
	BCF   TRISB,7
			;	PORTB.7=0;
	BCF   0x03,RP0
	BCF   PORTB,7
			;	PORTB.6=0;
	BCF   PORTB,6
			;	PORTB.5=0;
	BCF   PORTB,5
			;}
	RETURN
			;
			;void affichage_heure(unsigned adresse){
affichage_heure
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adresse_2
			;	tampon_s=0;
	CLRF  tampon_s
			;	lecture_donnee_horloge(0x85);
	MOVLW 133
	CALL  lecture_donnee_horloge
			;	curseur(adresse);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  adresse_2,W
	CALL  curseur
			;	affich_chiffre(tampon_s/10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tampon_s,W
	MOVWF arg1_5
	CLRF  arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	CALL  affich_chiffre
			;	affich_chiffre(tampon_s%10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tampon_s,W
	MOVWF arg1_9
	CLRF  arg1_9+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	CALL  affich_chiffre
			;	affich_chaine(":",1);
	MOVLW 124
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF chaine
	MOVLW 1
	CALL  affich_chaine
			;	lecture_donnee_horloge(0x83);
	MOVLW 131
	CALL  lecture_donnee_horloge
			;	affich_chiffre(tampon_s/10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tampon_s,W
	MOVWF arg1_5
	CLRF  arg1_5+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _divU16_8
	BCF   0x0A,PA0
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	CALL  affich_chiffre
			;	affich_chiffre(tampon_s%10);
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tampon_s,W
	MOVWF arg1_9
	CLRF  arg1_9+1
	MOVLW 10
	BSF   0x0A,PA0
	CALL  _remU16_8
	BCF   0x0A,PA0
	GOTO  affich_chiffre
			;}
			;
			;
			;void genere_car(void)
			;{
genere_car
			;	static const char car_1[] = {0x0,0xf,0x3,0x5,0x9,0x10,0x0,0x0};			//fleche haut
			;	static const char car_2[] = {0x0,0x10,0x9,0x5,0x3,0xf,0x0,0x0};			//fleche bas
			;	static const char car_3[] = {0x1f,0x10,0x10,0x10,0x10,0x10,0x1f,0x0};	//debut barre
			;	static const char car_4[] = {0x1f,0x0,0x0,0x0,0x0,0x0,0x1f,0x0};		//milleu barre
			;	static const char car_5[] = {0x1f,0x1,0x1,0x1,0x1,0x1,0x1f,0x0};		//fin barre
			;	static const char car_6[] = {0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x0};	//barre pleine
			;	unsigned i_car_a;
			;	PORT_RS=1;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   PORTB,1
			;	curseur(0x40);
	MOVLW 64
	CALL  curseur
			;	tempo_c();
	CALL  tempo_c
			;	for (i_car_a=0;i_car_a<8;i_car_a++){
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_car_a
m183	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_car_a,W
	BTFSC 0x03,Carry
	GOTO  m184
			;		affich_chiffre(car_1[i_car_a]-48);
	MOVLW 126
	ADDWF i_car_a,W
	CALL  _const1
	ADDLW 208
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_car_a,1
	GOTO  m183
			;	for (i_car_a=0;i_car_a<8;i_car_a++){
m184	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_car_a
m185	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_car_a,W
	BTFSC 0x03,Carry
	GOTO  m186
			;		affich_chiffre(car_2[i_car_a]-48);
	MOVLW 134
	ADDWF i_car_a,W
	CALL  _const1
	ADDLW 208
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_car_a,1
	GOTO  m185
			;	for (i_car_a=0;i_car_a<8;i_car_a++){
m186	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_car_a
m187	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_car_a,W
	BTFSC 0x03,Carry
	GOTO  m188
			;		affich_chiffre(car_3[i_car_a]-48);
	MOVLW 142
	ADDWF i_car_a,W
	CALL  _const1
	ADDLW 208
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_car_a,1
	GOTO  m187
			;	for (i_car_a=0;i_car_a<8;i_car_a++){
m188	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_car_a
m189	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_car_a,W
	BTFSC 0x03,Carry
	GOTO  m190
			;		affich_chiffre(car_4[i_car_a]-48);
	MOVLW 150
	ADDWF i_car_a,W
	CALL  _const1
	ADDLW 208
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_car_a,1
	GOTO  m189
			;	for (i_car_a=0;i_car_a<8;i_car_a++){
m190	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_car_a
m191	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_car_a,W
	BTFSC 0x03,Carry
	GOTO  m192
			;		affich_chiffre(car_5[i_car_a]-48);
	MOVLW 158
	ADDWF i_car_a,W
	CALL  _const1
	ADDLW 208
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_car_a,1
	GOTO  m191
			;	for (i_car_a=0;i_car_a<8;i_car_a++){
m192	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_car_a
m193	MOVLW 8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_car_a,W
	BTFSC 0x03,Carry
	GOTO  m194
			;		affich_chiffre(car_6[i_car_a]-48);
	MOVLW 166
	ADDWF i_car_a,W
	CALL  _const1
	ADDLW 208
	CALL  affich_chiffre
			;	}
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_car_a,1
	GOTO  m193
			;}
m194	RETURN
			;#pragma codepage 1
	ORG 0x0B4F
			;void echelle_bft(unsigned long v_comp){
echelle_bft
			;	unsigned bft;
			;	bft=0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  bft
			;	curseur(0xC0);
	MOVLW 192
	BCF   0x0A,PA0
	CALL  curseur
	BSF   0x0A,PA0
			;	if(v_comp>10){
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v_comp+1,W
	BTFSS 0x03,Zero_
	GOTO  m195
	MOVLW 11
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m196
			;		affich_chiffre(213);
m195	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft=1;
	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF bft
			;	}
			;	else{
	GOTO  m197
			;		affich_chiffre(210);
m196	MOVLW 210
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft+=0;
			;	}
			;	if(v_comp>60){
m197	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v_comp+1,W
	BTFSS 0x03,Zero_
	GOTO  m198
	MOVLW 61
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m199
			;		affich_chiffre(213);
m198	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m200
			;		affich_chiffre(211);
m199	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>120){
m200	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v_comp+1,W
	BTFSS 0x03,Zero_
	GOTO  m201
	MOVLW 121
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m202
			;		affich_chiffre(213);
m201	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m203
			;		affich_chiffre(211);
m202	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>200){
m203	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  v_comp+1,W
	BTFSS 0x03,Zero_
	GOTO  m204
	MOVLW 201
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m205
			;		affich_chiffre(213);
m204	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m206
			;		affich_chiffre(211);
m205	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>290){
m206	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m208
	BTFSS 0x03,Zero_
	GOTO  m207
	MOVLW 35
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m208
			;		affich_chiffre(213);
m207	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m209
			;		affich_chiffre(211);
m208	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>390){
m209	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m211
	BTFSS 0x03,Zero_
	GOTO  m210
	MOVLW 135
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m211
			;		affich_chiffre(213);
m210	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m212
			;		affich_chiffre(211);
m211	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>500){
m212	MOVLW 1
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m214
	BTFSS 0x03,Zero_
	GOTO  m213
	MOVLW 245
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m214
			;		affich_chiffre(213);
m213	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m215
			;		affich_chiffre(211);
m214	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>620){
m215	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m217
	BTFSS 0x03,Zero_
	GOTO  m216
	MOVLW 109
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m217
			;		affich_chiffre(213);
m216	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m218
			;		affich_chiffre(211);
m217	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>750){
m218	MOVLW 2
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m220
	BTFSS 0x03,Zero_
	GOTO  m219
	MOVLW 239
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m220
			;		affich_chiffre(213);
m219	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m221
			;		affich_chiffre(211);
m220	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>890){
m221	MOVLW 3
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m223
	BTFSS 0x03,Zero_
	GOTO  m222
	MOVLW 123
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m223
			;		affich_chiffre(213);
m222	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m224
			;		affich_chiffre(211);
m223	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>1030){
m224	MOVLW 4
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m226
	BTFSS 0x03,Zero_
	GOTO  m225
	MOVLW 7
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m226
			;		affich_chiffre(213);
m225	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m227
			;		affich_chiffre(211);
m226	MOVLW 211
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	if(v_comp>1180){
m227	MOVLW 4
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF v_comp+1,W
	BTFSS 0x03,Carry
	GOTO  m229
	BTFSS 0x03,Zero_
	GOTO  m228
	MOVLW 157
	SUBWF v_comp,W
	BTFSS 0x03,Carry
	GOTO  m229
			;		affich_chiffre(213);
m228	MOVLW 213
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;		bft++;
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  bft,1
			;	}
			;	else{
	GOTO  m230
			;		affich_chiffre(212);
m229	MOVLW 212
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	
			;	curseur(0xCD);
m230	MOVLW 205
	BCF   0x0A,PA0
	CALL  curseur
	BSF   0x0A,PA0
			;	if(bft<10){
	MOVLW 10
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF bft,W
	BTFSC 0x03,Carry
	GOTO  m231
			;		affich_chiffre(112);
	MOVLW 112
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	else{
	GOTO  m232
			;		affich_chiffre(bft/10);
m231	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  bft,W
	MOVWF arg1_5
	CLRF  arg1_5+1
	MOVLW 10
	CALL  _divU16_8
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  arg1_5,W
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
			;	}
			;	affich_chiffre(bft%10);
m232	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  bft,W
	MOVWF arg1_9
	CLRF  arg1_9+1
	MOVLW 10
	CALL  _remU16_8
	BCF   0x0A,PA0
	CALL  affich_chiffre
	BSF   0x0A,PA0
	RETURN

	END


; *** KEY INFO ***

; 0x032B P0   12 word(s)  0 % : tempo_c
; 0x0347 P0   41 word(s)  2 % : tempo_l
; 0x0337 P0   16 word(s)  0 % : tempo_longue
; 0x0370 P0    8 word(s)  0 % : impuls
; 0x039A P0   14 word(s)  0 % : affich_chiffre
; 0x03A8 P0   16 word(s)  0 % : clear
; 0x03B8 P0   19 word(s)  0 % : curseur
; 0x03CB P0   75 word(s)  3 % : init_lcd
; 0x0378 P0   34 word(s)  1 % : affich_chaine
; 0x0416 P0  118 word(s)  5 % : affichage_vitesse
; 0x048C P0  187 word(s)  9 % : ecrire_heure
; 0x0547 P0   86 word(s)  4 % : ecrire_donnee_horloge
; 0x059D P0   82 word(s)  4 % : lecture_donnee_horloge
; 0x062F P0  115 word(s)  5 % : genere_car
; 0x05EF P0   64 word(s)  3 % : affichage_heure
; 0x0004 P0   73 word(s)  3 % : ils
; 0x00C6 P0  613 word(s) 29 % : main
; 0x004D P0  121 word(s)  5 % : _const1

; 0x0800 P1  119 word(s)  5 % : _fmul24
; 0x0877 P1  166 word(s)  8 % : _fdiv24
; 0x091D P1  224 word(s) 10 % : _fadd24
; 0x09FD P1   88 word(s)  4 % : _int24ToFloat24
; 0x0A55 P1  106 word(s)  5 % : _float24ToInt24
; 0x0ABF P1   21 word(s)  1 % : _mult8x8
; 0x0AD4 P1   29 word(s)  1 % : _divU16_8
; 0x0AF1 P1   34 word(s)  1 % : _divU16_16
; 0x0B13 P1   28 word(s)  1 % : _remU16_8
; 0x0B2F P1   32 word(s)  1 % : _remU16_16
; 0x0B4F P1  323 word(s) 15 % : echelle_bft

; RAM usage: 85 bytes (16 local), 283 bytes free
; Maximum call level: 3 (+1 for interrupt)
;  Codepage 0 has 1695 word(s) :  82 %
;  Codepage 1 has 1170 word(s) :  57 %
; Total of 2865 code words (69 %)
