#include "header_anemo.h"
void tempo_c(void){
	for(i=0;i<8;i++);
}

void tempo_l(void){
	for(i=0;i<240;i++);
}

void impuls(void){
	PORTB.2=1;
	nop();
	nop();
	nop();
	PORTB.2=0;
	nop();
}


void affich_chaine(const char * chaine){
while(*chaine!='\0')
	{
	char tempon;
	tempon=chaine[i]>>4;
	PORTA=tempon;
	impuls();
	PORTA=chaine[i];
	impuls();
	tempo_c();
	chaine++;
	}
}

void affich_chiffre(char chiff){
chiff=chiff+48;
PORTA=chiff>>4;
impuls();
PORTA=chiff;
impuls();
tempo_c();
}

	
void clear(void){
PORTB.1=0;
PORTA=0;
impuls();
PORTA=1;
impuls();
tempo_l();
PORTB.1=1;
}

void home(void){
PORTB.1=0;
PORTA=0;
impuls();
PORTA=2;
impuls();
tempo_l();
PORTB.1=1;
}

void curseur(char place){
place=place + 0b10000000;
PORTB.1=0;
PORTA=place>>4;
impuls();
PORTA=place;
impuls();
tempo_c();
PORTB.1=1;
}

void init_lcd(void){
for(a=0;a<255;a++){//On attend que le LCD s'allume
	tempo_l();
	}
PORTA=3;//mode 8 bits
impuls();
tempo_c();

PORTA=3;//mode 8 bits
impuls();
tempo_c();

PORTA=3;//mode 8 bits
impuls();
tempo_c();

PORTA=2;//mode 4 bits
impuls();
tempo_c();

PORTA=2;//mode 4 bits + 1 ligne + caractre 5*7
impuls();
PORTA=8;
impuls();
tempo_c();

PORTA=0;//allumage affichage + cache curseur
impuls();
PORTA=12;
impuls();
tempo_c();

PORTA=0;//le curseur bouge vers la droite
impuls();
PORTA=4;
impuls();
tempo_c();

clear();//On efface l'afficheur


PORTA=0;//Incrmentation du curseur a chaque nouvelle donne
impuls();
PORTA=6;
impuls();
tempo_c();

PORTB.1=1;//On passe en mode "donnes"
clear();
}